/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2018 All Rights Reserved.
 */
package com.abssqr.plat.biz.shared.dispatcher.planAstStat;

import com.abssqr.plat.biz.shared.dispatcher.DispatcherExecutor;
import com.abssqr.plat.biz.shared.dispatcher.DispatcherLoader;
import com.abssqr.plat.biz.shared.dispatcher.DispatcherStarter;
import com.abssqr.plat.common.model.domain.plan.PlanAstStatTask;
import com.abssqr.plat.common.model.repo.ast.PlanAstStatTaskRepo;
import com.abssqr.plat.core.service.host.HostManager;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * @author zhenxuan.luo
 * @version com.abssqr.plat.biz.shared.task.task: PlanAstStatTaskStarter.java, v 0.1 2018-01-08 02:42 hongwei
 * .wang Exp $
 */
@Component
public class PlanAstStatTaskStarter extends DispatcherStarter<PlanAstStatTask> {
    
    public static String JOB_NAME = "PlanAstStatTaskDispatcher";
    
    @Autowired
    private PlanAstStatTaskExecutor planAstStatTaskExecutor;
    @Autowired
    private PlanAstStatTaskLoader   planAstStatTaskLoader;
    @Autowired
    private HostManager             hostManager;
    @Autowired
    private PlanAstStatTaskRepo     planAstStatTaskRepo;
    
    private int coreSize = 2;
    
    private int maxSize = 3;
    
    private int hungrySize = 2;
    
    @Override
    protected void recovery() {
        planAstStatTaskRepo.updateHangTasksByIp(hostManager.getHostInfo().getHostName());
    }
    
    @Override
    public String getName() {
        return JOB_NAME;
    }
    
    @Override
    protected int getCoreSize() {
        return coreSize;
    }
    
    @Override
    protected int getMaxSize() {
        return maxSize;
    }
    
    @Override
    protected int getQueueSize() {
        return 4;
    }
    
    @Override
    protected int getHungrySize() {
        return hungrySize;
    }
    
    @Override
    protected DispatcherLoader<PlanAstStatTask> getLoader() {
        return planAstStatTaskLoader;
    }
    
    @Override
    protected DispatcherExecutor<PlanAstStatTask> getExecutor() {
        return planAstStatTaskExecutor;
    }
    
}
