/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.domain.config;

import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.stereotype.Component;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.domain: WkPayConfig.java, v 0.1 2019-06-19 19:00 bangis.wangdf Exp $
 */

@Component
@ConfigurationProperties(prefix = "wkabs.pay")
public class WkPayConfig {
    /**
     * 项目编号
     */
    private String projNo;
    /**
     * 项目名称
     */
    private String projName;
    /**
     * 余额类型（
     * 本地("0", "本地"),
     * 渠道余额("1", "渠道余额"),）
     */
    private String balanceType;
    /**
     * 交易代理结果回调
     */
    private String tradeCallBackUrl;
    /**
     * 五矿支付wsdl地址
     */
    private String host;

    public String getProjNo() {
        return projNo;
    }

    public void setProjNo(String projNo) {
        this.projNo = projNo;
    }

    public String getProjName() {
        return projName;
    }

    public void setProjName(String projName) {
        this.projName = projName;
    }

    public String getHost() {
        return host;
    }

    public void setHost(String host) {
        this.host = host;
    }

    public String getTradeCallBackUrl() {
        return tradeCallBackUrl;
    }

    public void setTradeCallBackUrl(String tradeCallBackUrl) {
        this.tradeCallBackUrl = tradeCallBackUrl;
    }

    public String getBalanceType() {
        return balanceType;
    }

    public void setBalanceType(String balanceType) {
        this.balanceType = balanceType;
    }
}
