/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.domain.opr.request.trade;

import javax.xml.bind.annotation.XmlRootElement;

import com.abssqr.plat.common.integration.wk.domain.WkObject;
import com.abssqr.plat.common.integration.wk.enums.WkAccountTypeEnum;
import com.abssqr.plat.common.integration.wk.enums.WkChannelNoEnum;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.domain.opr.request.trade: TdAccountInfo.java, v 0.1 2019-06-20 20:51
 * bangis.wangdf Exp $
 */
@XmlRootElement(name = "AccountInfo")
public class TdAccountInfo extends WkObject {
    /**
     * 账户号	字符	32	Y	银行账户号或支付平台账户号
     **/
    private String            accountNo;
    /**
     * 账户类型	枚举	2	Y	详见4.7
     **/
    private WkAccountTypeEnum accountType;
    /**
     * 账户姓名	字符	64	S	账户姓名，使用银行账户时非空
     **/
    private String            accountName;
    /**
     * 支付系统渠道（银行）编号	枚举	10	S	见4.3渠道代码列表，使用客户银行账户时非空
     **/
    private WkChannelNoEnum   channelNo;
    /**
     * 联行号	枚举	20	S	联行号，暂时未使用
     **/
    private String            bankDetailNo;
    /**
     * 开户行名称	字符	128	S	网点/支行名称 当账户类型为企业账户时该项必填
     **/
    private String            bankName;
    /**
     * 开户行所在省	字符	128	S	网点/支行所在省 当账户类型为企业账户时该项必填
     **/
    private String            province;
    /**
     * 开户行所在市	字符	128	S	网点/支行所在市 当账户类型为企业账户时该项必填
     **/
    private String            city;
    /**
     * 信用卡3位安全码	字符	3	S	信用卡3位安全码 账户类型为个人信用卡必填
     **/
    private String            CVN2;
    /**
     * 信用卡有效期	字符	4	S	格式 YYMM 账户类型为个人信用卡必填
     **/
    private String          VALDATE;
    /**
     * 手机号	字符	15	N	手机号
     **/
    private String          phoneNo;
    /**
     * email	字符	20	N	email
     **/
    private String          Email;
    /**
     * 证件类型	字符	5	Y	见4.6目前仅支持身份证
     * 0	个人	身份证
     * 1	个人	户口簿
     * 2	个人	护照
     * 3	个人	军官证
     * 4	个人	士兵证
     * 5	个人	港澳居民来往内地通行证
     * 6	个人	台湾同胞来往内地通行证
     * 7	个人	临时身份证
     * 8	个人	外国人居留证
     * 9	个人	警官证
     * X	个人/企业	其他证件
     * A	企业	组织机构代码证号
     * B	企业	营业执照号码
     * C	企业	登记证书
     * D	企业	国税登记证号码
     * E	企业	地税登记证号码
     * F	企业	开户许可证
     * G	企业	事业单位编号
     * I	企业	金融许可证编号
     **/
    private String            certificateType;
    /**
     * 证件号	字符	20	Y	证件号
     **/
    private String            certificateNo;

    public String getAccountNo() {
        return accountNo;
    }

    public void setAccountNo(String accountNo) {
        this.accountNo = accountNo;
    }

    public WkAccountTypeEnum getAccountType() {
        return accountType;
    }

    public void setAccountType(WkAccountTypeEnum accountType) {
        this.accountType = accountType;
    }

    public String getAccountName() {
        return accountName;
    }

    public void setAccountName(String accountName) {
        this.accountName = accountName;
    }

    public WkChannelNoEnum getChannelNo() {
        return channelNo;
    }

    public void setChannelNo(WkChannelNoEnum channelNo) {
        this.channelNo = channelNo;
    }

    public String getBankDetailNo() {
        return bankDetailNo;
    }

    public void setBankDetailNo(String bankDetailNo) {
        this.bankDetailNo = bankDetailNo;
    }

    public String getBankName() {
        return bankName;
    }

    public void setBankName(String bankName) {
        this.bankName = bankName;
    }

    public String getProvince() {
        return province;
    }

    public void setProvince(String province) {
        this.province = province;
    }

    public String getCity() {
        return city;
    }

    public void setCity(String city) {
        this.city = city;
    }

    public String getCVN2() {
        return CVN2;
    }

    public void setCVN2(String CVN2) {
        this.CVN2 = CVN2;
    }

    public String getVALDATE() {
        return VALDATE;
    }

    public void setVALDATE(String VALDATE) {
        this.VALDATE = VALDATE;
    }

    public String getPhoneNo() {
        return phoneNo;
    }

    public void setPhoneNo(String phoneNo) {
        this.phoneNo = phoneNo;
    }

    public String getEmail() {
        return Email;
    }

    public void setEmail(String email) {
        Email = email;
    }

    public String getCertificateType() {
        return certificateType;
    }

    public void setCertificateType(String certificateType) {
        this.certificateType = certificateType;
    }

    public String getCertificateNo() {
        return certificateNo;
    }

    public void setCertificateNo(String certificateNo) {
        this.certificateNo = certificateNo;
    }
}
