/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.domain.opr.request.trade;

import java.util.List;

import javax.xml.bind.annotation.XmlRootElement;

import com.abssqr.plat.common.integration.wk.domain.WkObject;
import com.abssqr.plat.common.integration.wk.enums.WkChannelNoEnum;
import com.abssqr.plat.common.integration.wk.enums.EnTradeTypeEnum;
import com.abssqr.plat.common.integration.wk.utils.WkSequenceUtil.Trade;

/**
 * 交易详情
 *
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.domain.opr.request: TdEntryInfo.java, v 0.1 2019-06-20 20:19 bangis
 * .wangdf Exp $
 */
@XmlRootElement(name = "EntryInfo")
public class TdEntryInfo extends WkObject {
    /**
     EntryNo	条目号	字符	50	Y	业务系统保证唯一，并以业务系统编号开头
     EnTradeType	条目交易类型	枚举	2	Y	详见4.4
     Amount	金额	金钱	10	Y	交易金额(单位:分)
     EntryTypeNo	条目类型编号	数字	10	Y	最大长度10位数字
     须由交易类型编号开头
     统一交易内编号长度必须一致，统一交易编号补不能重复
     (交易优先级按照条目类型编号，由小到大)
     ChannelNo	渠道编号	字符	6	S	指定渠道，选填，如果有效则直接使用指定渠道而不路由，如果无效则直接失败。
     SourceAccountList	源交易账户信息列表	列表		Y	列表内容为SourceAccountInfo,不同交易对列表数量要求不同，详见4.4 根据扣款放款转换
     TargetAccountList	目标交易账户信息列表	列表		Y	列表内容为 TargetAccountInfo，不同交易对列表数量要求不同，详见4.4
     Remark1	备注1	字符	128	N	备注1
     Remark2	备注2	字符	128	N	备注2
     Remark3	备注3	字符	128	N	备注3
     */

    /**
     * @see Trade#genEntryNo()
     * 条目号	字符	50	Y	业务系统保证唯一，并以业务系统编号开头
     */
    private String                    entryNo;
    /**
     * 条目交易类型	枚举	2	Y	详见4.4
     */
    private EnTradeTypeEnum           enTradeType;
    /**
     * 金额	金钱	10	Y	交易金额(单位:分)
     */
    private long                      amount;
    /**
     * @see Trade#genEntryTypeNo(EnTradeTypeEnum, int)
     * 条目类型编号	数字	10	Y	最大长度10位数字
     * 须由交易类型编号开头
     * 统一交易内编号长度必须一致，统一交易编号补不能重复
     * (交易优先级按照条目类型编号，由小到大)
     */
    private String                    entryTypeNo;
    /**
     * 渠道编号	字符	6	S	指定渠道，选填，如果有效则直接使用指定渠道而不路由，如果无效则直接失败。
     */
    private WkChannelNoEnum           channelNo;
    /**
     * 源交易账户信息列表	列表		Y	列表内容为SourceAccountInfo,不同交易对列表数量要求不同，详见4.4 根据扣款放款转换
     */
    private List<TdSourceAccountInfo> sourceAccountList;
    /**
     * TargetAccountList	目标交易账户信息列表	列表		Y	列表内容为 TargetAccountInfo，不同交易对列表数量要求不同，详见4.4
     */
    private List<TdTargetAccountInfo> targetAccountList;
    private String                    remark1;
    private String                    remark2;
    private String                    remark3;

    public String getEntryNo() {
        return entryNo;
    }

    public void setEntryNo(String entryNo) {
        this.entryNo = entryNo;
    }

    public EnTradeTypeEnum getEnTradeType() {
        return enTradeType;
    }

    public void setEnTradeType(EnTradeTypeEnum enTradeType) {
        this.enTradeType = enTradeType;
    }

    public long getAmount() {
        return amount;
    }

    public void setAmount(long amount) {
        this.amount = amount;
    }

    public String getEntryTypeNo() {
        return entryTypeNo;
    }

    public void setEntryTypeNo(String entryTypeNo) {
        this.entryTypeNo = entryTypeNo;
    }

    public WkChannelNoEnum getChannelNo() {
        return channelNo;
    }

    public void setChannelNo(WkChannelNoEnum channelNo) {
        this.channelNo = channelNo;
    }

    public List<TdSourceAccountInfo> getSourceAccountList() {
        return sourceAccountList;
    }

    public void setSourceAccountList(List<TdSourceAccountInfo> sourceAccountList) {
        this.sourceAccountList = sourceAccountList;
    }

    public List<TdTargetAccountInfo> getTargetAccountList() {
        return targetAccountList;
    }

    public void setTargetAccountList(List<TdTargetAccountInfo> targetAccountList) {
        this.targetAccountList = targetAccountList;
    }

    public String getRemark1() {
        return remark1;
    }

    public void setRemark1(String remark1) {
        this.remark1 = remark1;
    }

    public String getRemark2() {
        return remark2;
    }

    public void setRemark2(String remark2) {
        this.remark2 = remark2;
    }

    public String getRemark3() {
        return remark3;
    }

    public void setRemark3(String remark3) {
        this.remark3 = remark3;
    }
}
