/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.domain.opr.request.trade;

import java.util.List;

import com.abssqr.plat.common.integration.wk.domain.WkObject;
import com.abssqr.plat.common.integration.wk.enums.TradeTypeEnum;

/**
 * 交易信息
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.domain.opr.request: TradeInfo.java, v 0.1 2019-06-20 20:15 bangis
 * .wangdf Exp $
 */
public class TradeInfo extends WkObject {
    /**
     * TradeNo	交易号	字符	50	Y	业务系统保证唯一，并以业务系统编号开头
     * TradeTypeNo	交易类型编号	数字	6	Y	最大长度6位数字  001放，002扣款
     * TotalEntryNum	总条目数	字符	2	Y	最大10(同一交易最多10个条目)
     * EntryList	交易详情	列表		Y	列表内容为 TdEntryInfo
     */

    /**
     *
     * 交易号	字符	50	Y	业务系统保证唯一，并以业务系统编号开头
     */
    private String            tradeNo;
    /**
     * 交易类型编号	数字	6	Y	最大长度6位数字  001放，002扣款
     */
    private TradeTypeEnum     tradeTypeNo;
    /**
     * 总条目数	字符	2	Y	最大10(同一交易最多10个条目)
     */
    private Long              totalEntryNum;
    /**
     * 交易详情	列表		Y	列表内容为 TdEntryInfo
     */
    private List<TdEntryInfo> entryList;

    public String getTradeNo() {
        return tradeNo;
    }

    public void setTradeNo(String tradeNo) {
        this.tradeNo = tradeNo;
    }

    public TradeTypeEnum getTradeTypeNo() {
        return tradeTypeNo;
    }

    public void setTradeTypeNo(TradeTypeEnum tradeTypeNo) {
        this.tradeTypeNo = tradeTypeNo;
    }

    public Long getTotalEntryNum() {
        if(totalEntryNum==null&&this.entryList!=null){
            return Long.valueOf(this.entryList.size());
        }
        return totalEntryNum;
    }

    public void setTotalEntryNum(Long totalEntryNum) {
        this.totalEntryNum = totalEntryNum;
    }

    public List<TdEntryInfo> getEntryList() {
        return entryList;
    }

    public void setEntryList(List<TdEntryInfo> entryList) {
        this.entryList = entryList;
    }
}
