/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.domain.qry.request.trade;

import java.util.List;

import com.abssqr.plat.common.integration.wk.domain.WkBody;
import com.abssqr.plat.common.integration.wk.enums.TradeQueryTypeEnum;

/**
 * 交易结果查询
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.domain.qry.request.trade: TradeQuery.java, v 0.1 2019-06-21 21:23
 * bangis.wangdf Exp $
 */
public class TradeQuery extends WkBody {
    /**
     QueryType	查询类型	字符	2	Y	1 按日期区间查询
     2 按接口流水号查询
     3按交易交易号查询
     4按交易条目号查询
     StartDate	开始日期	枚举	10	S	“查询类型”为1时必传
     格式：yyyy-MM-dd
     EndDate	结束日期	枚举	10	S	“查询类型”为1时必传
     格式：yyyy-MM-dd
     QueryList	查询条件	列表		S	“查询类型”为2、3、4时必传，列表内容为 TradeItem，
     一次请求最多50个查询条件
     */
    /**
     * 查询类型
     */
    private TradeQueryTypeEnum queryType;
    private String             startDate;
    private String             endDate;
    private List<TradeItem>    queryList;

    public TradeQueryTypeEnum getQueryType() {
        return queryType;
    }

    public void setQueryType(TradeQueryTypeEnum queryType) {
        this.queryType = queryType;
    }

    public String getStartDate() {
        return startDate;
    }

    public void setStartDate(String startDate) {
        this.startDate = startDate;
    }

    public String getEndDate() {
        return endDate;
    }

    public void setEndDate(String endDate) {
        this.endDate = endDate;
    }

    public List<TradeItem> getQueryList() {
        return queryList;
    }

    public void setQueryList(List<TradeItem> queryList) {
        this.queryList = queryList;
    }
}
