/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.domain.qry.response.trade;

import java.util.Date;

import javax.xml.bind.annotation.XmlRootElement;

import com.abssqr.plat.common.integration.wk.domain.WkObject;
import com.abssqr.plat.common.integration.wk.enums.WkChannelNoEnum;
import com.abssqr.plat.common.integration.wk.enums.EnTradeTypeEnum;
import com.abssqr.plat.common.integration.wk.enums.WkTradeStatusEnum;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.domain.qry.response.trade: TradeResultItem.java, v 0.1 2019-06-21
 * 21:37 bangis.wangdf Exp $
 */
@XmlRootElement(name = "PayInfo")
public class TradeResultItem extends WkObject {
    /**
     FlowNo	接口流水号	枚举	32	Y	头报文UUID
     TradeNo	交易号	字符	32	Y
     TradeTypeNo	交易业务类型	字符	10	Y
     TradeChannel	交易渠道	枚举	8	Y	4.3渠道代码表
     EntryNo	条目号	字符	32	Y
     EntryTypeNo	条目业务类型	金额	10	Y
     RpayMoney	请求支付金额	字符	10	Y	(单位分)
     PayMoney	实际支付金额	字符	10	Y	(单位分)
     EnTradeType	条目交易类型	枚举	2	Y	见4.4
     PayTime	交易时间	字符	20	Y	yyyy-MM-dd HH:mm:ss
     Status	交易状态	字符	2	Y	见4.5
     Message	交易信息反馈	字符	128	Y
     */

    /**
     * 接口流水号	枚举	32	Y	头报文UUID
     */
    private String          flowNo;
    /**
     * 交易号	字符	32	Y
     */
    private String          tradeNo;
    /**
     * 交易业务类型	字符	10	Y
     */
    private String          tradeTypeNo;
    /**
     * 交易渠道	枚举	8	Y	4.3渠道代码表
     */
    private WkChannelNoEnum   tradeChannel;
    /**
     * 条目号	字符	50	Y	业务系统保证唯一，并以业务系统编号开头
     */
    private String            entryNo;
    /**
     * 请求支付金额  	Y	交易金额(单位:分)
     */
    private long              rpayMoney;
    /**
     * 实际支付金额
     */
    private long              payMoney;
    /**
     * 条目交易类型	枚举	2	Y	详见4.4
     */
    private EnTradeTypeEnum   enTradeType;
    /**
     * 交易时间	字符	20	Y	yyyy-MM-dd HH:mm:ss
     */
    private Date              payTime;
    /**
     * 交易状态	字符	2	Y	见4.5
     */
    private WkTradeStatusEnum status;
    /**
     * 交易信息反馈
     */
    private String            message;

    public String getFlowNo() {
        return flowNo;
    }

    public void setFlowNo(String flowNo) {
        this.flowNo = flowNo;
    }

    public String getTradeNo() {
        return tradeNo;
    }

    public void setTradeNo(String tradeNo) {
        this.tradeNo = tradeNo;
    }

    public String getTradeTypeNo() {
        return tradeTypeNo;
    }

    public void setTradeTypeNo(String tradeTypeNo) {
        this.tradeTypeNo = tradeTypeNo;
    }

    public WkChannelNoEnum getTradeChannel() {
        return tradeChannel;
    }

    public void setTradeChannel(WkChannelNoEnum tradeChannel) {
        this.tradeChannel = tradeChannel;
    }

    public String getEntryNo() {
        return entryNo;
    }

    public void setEntryNo(String entryNo) {
        this.entryNo = entryNo;
    }

    public long getRpayMoney() {
        return rpayMoney;
    }

    public void setRpayMoney(long rpayMoney) {
        this.rpayMoney = rpayMoney;
    }

    public long getPayMoney() {
        return payMoney;
    }

    public void setPayMoney(long payMoney) {
        this.payMoney = payMoney;
    }

    public EnTradeTypeEnum getEnTradeType() {
        return enTradeType;
    }

    public void setEnTradeType(EnTradeTypeEnum enTradeType) {
        this.enTradeType = enTradeType;
    }

    public Date getPayTime() {
        return payTime;
    }

    public void setPayTime(Date payTime) {
        this.payTime = payTime;
    }

    public WkTradeStatusEnum getStatus() {
        return status;
    }

    public void setStatus(WkTradeStatusEnum status) {
        this.status = status;
    }

    public String getMessage() {
        return message;
    }

    public void setMessage(String message) {
        this.message = message;
    }
}
