/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * 表示平台所在业务类别
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: RequestTypeEnum.java, v 0.1 2019-06-18 14:04 bangis.wangdf Exp $
 */
public enum ComIdEnum implements WkEnum {
    /**
     ufc0000	支付平台
     000003	小微信贷系统
     **/

    支付平台("ufc0000", "支付平台"),
    小微信贷系统("000003", "小微信贷系统"),
    资产转让("000004", "资产转让"),

    ;

    private static final Map<String, ComIdEnum>
        codeMap = new HashMap<String, ComIdEnum>();

    static {
        for (ComIdEnum item : ComIdEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    private ComIdEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static ComIdEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public ComIdEnum getByWkCode(String code) {
        return getByCode(code);
    }
}

