/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author yangcheng
 * @version EnTradeTypeEnum.java, v0.12019-06-1817:03 yangchengExp$
 */
public enum EnTradeTypeEnum implements WkEnum {
    
    /**
     01	放款
     02	扣款
     03	充值
     04	提现
     05	挂账充值
     06	挂账提现
     **/

    放款("01", "放款"),
    扣款("02", "扣款"),
    充值("03", "充值"),
    提现("04", "提现"),
    挂账充值("05", "挂账充值"),
    挂账提现("06", "挂账提现"),
    ;
    
    private static final Map<String, EnTradeTypeEnum>
            codeMap = new HashMap<String, EnTradeTypeEnum>();
    
    static {
        for (EnTradeTypeEnum item : EnTradeTypeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }
    
    private String code;
    private String desc;
    
    private EnTradeTypeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }
    
    public static EnTradeTypeEnum getByCode(String code) {
        return codeMap.get(code);
    }
    
    @Override
    public String getCode() {
        return code;
    }
    
    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public EnTradeTypeEnum getByWkCode(String code) {
        return getByCode(code);
    }
}


