/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author yangcheng
 * @version LocalOrChannelEnum.java, v0.12019-06-1815:56 yangchengExp$
 */
public enum LocalOrChannelEnum implements WkEnum {
    /**
     0	本地
     1	渠道余额
     **/

    本地("0", "本地"),
    渠道余额("1", "渠道余额"),
    ;
    
    private static final Map<String, LocalOrChannelEnum>
            codeMap = new HashMap<String, LocalOrChannelEnum>();
    
    static {
        for (LocalOrChannelEnum item : LocalOrChannelEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }
    
    private String code;
    private String desc;
    
    private LocalOrChannelEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }
    
    public static LocalOrChannelEnum getByCode(String code) {
        return codeMap.get(code);
    }
    
    @Override
    public String getCode() {
        return code;
    }
    
    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public LocalOrChannelEnum getByWkCode(String code) {
        return getByCode(code);
    }
}
