/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author yangcheng
 * @version PlatResultCodeEnum.java, v0.12019-06-1814:48 yangchengExp$
 */
public enum PlatResultCodeEnum implements WkEnum {
    /**
     * 10000	成功
     * 90000	支付平台异常
     **/

    成功("10000", "成功"),
    支付平台异常("90000", "支付平台异常"),
    服务异常("99999", "服务异常"),
    异常("9", "异常"),
    未知("xxxx", "未知"),
    ;

    private static final Map<String, PlatResultCodeEnum>
        codeMap = new HashMap<String, PlatResultCodeEnum>();

    static {
        for (PlatResultCodeEnum item : PlatResultCodeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    private PlatResultCodeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static PlatResultCodeEnum getByCode(String code) {
        PlatResultCodeEnum result = codeMap.get(code);
        if (result == null) {
            if (code.startsWith(异常.code)) {
                result = 异常;
            } else {
                return 未知;
            }
        }
        return result;
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public PlatResultCodeEnum getByWkCode(String code) {
        return getByCode(code);
    }
}
