/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: ProjStateEnum.java, v 0.1 2019-06-19 10:56 bangis.wangdf Exp $
 */
public enum ProjStateEnum implements WkEnum {

    生效("01", "生效"),
    失效("02", "失效"),
    ;

    private static final Map<String, ProjStateEnum>
        codeMap = new HashMap<String, ProjStateEnum>();

    static {
        for (ProjStateEnum item : ProjStateEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    private ProjStateEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static ProjStateEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public ProjStateEnum  getByWkCode(String code) {
        return getByCode(code);
    }
}