/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author yangcheng
 * @version QueryTypeEnum.java, v0.12019-06-1816:31 yangchengExp$
 */
public enum QueryTypeEnum implements WkEnum{
    /**
     1 按日期区间查询
     2 按接口流水号查询
     3 按交易交易号查询
     4 按交易条目号查询
     **/
    
    QT_1("1", "按日期区间查询"),
    QT_2("2", "按接口流水号查询"),
    QT_3("3", "按交易交易号查询"),
    QT_4("4", "按交易条目号查询"),
    
    ;
    
    private static final Map<String, QueryTypeEnum>
            codeMap = new HashMap<String, QueryTypeEnum>();
    
    static {
        for (QueryTypeEnum item : QueryTypeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }
    
    private String code;
    private String desc;
    
    private QueryTypeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }
    
    public static QueryTypeEnum getByCode(String code) {
        return codeMap.get(code);
    }
    
    @Override
    public String getCode() {
        return code;
    }
    
    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public QueryTypeEnum  getByWkCode(String code) {
        return getByCode(code);
    }
}