/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: RequestTypeEnum.java, v 0.1 2019-06-18 14:04 bangis.wangdf
 * Exp $
 */
public enum RequestTypeEnum implements WkEnum {
    /**
     * 账户信息维护	A100002	1	同步
     * 账户状态维护	A100003	1	同步
     * 交易代理	P100001	1-50	异步
     * 账户余额查询	B100002	1	同步
     * 交易结果查询	B100007	1	同步
     * 个人要素验证	B100006	1	同步
     * A100011  租户信息维护接口   同步
     **/

    A100002("A100002", "账户信息维护", WkAsynEnum.是),
//    A100003("A100003", "账户状态维护", WkAsynEnum.是),
    A100011("A100011", "租户信息维护", WkAsynEnum.是),
    P100001("P100001", "交易代理", WkAsynEnum.否),
    B100002("B100002", "账户余额查询", WkAsynEnum.是),
    B100007("B100007", "交易结果查询", WkAsynEnum.是),

    ;

    private static final Map<String, RequestTypeEnum>
        codeMap = new HashMap<String, RequestTypeEnum>();

    static {
        for (RequestTypeEnum item : RequestTypeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private WkAsynEnum asyn;
    private String     code;
    private String     desc;

    private RequestTypeEnum(String code, String desc, WkAsynEnum asyn) {
        this.code = code;
        this.desc = desc;
        this.asyn = asyn;
    }

    public static RequestTypeEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    public WkAsynEnum getAsyn() {
        return asyn;
    }

    @Override
    public RequestTypeEnum getByWkCode(String code) {
        return getByCode(code);
    }
}

