/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author yangcheng
 * @version SettleTypeEnum.java, v0.12019-06-1815:33 yangchengExp$
 */
public enum SettleTypeEnum implements WkEnum {
    
    /**
     01	实时结算
     02	定时自动结算
     **/

    实时结算("01", "实时结算"),
    定时自动结算("02", "定时自动结算"),
    ;
    
    private static final Map<String, SettleTypeEnum>
            codeMap = new HashMap<String, SettleTypeEnum>();
    
    static {
        for (SettleTypeEnum item : SettleTypeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }
    
    private String code;
    private String desc;
    
    private SettleTypeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }
    
    public static SettleTypeEnum getByCode(String code) {
        return codeMap.get(code);
    }
    
    @Override
    public String getCode() {
        return code;
    }
    
    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public SettleTypeEnum getByWkCode(String code) {
        return getByCode(code);
    }
}
