/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: TradeQueryTypeEnum.java, v 0.1 2019-06-21 21:25 bangis
 * .wangdf Exp $
 */
public enum TradeQueryTypeEnum implements WkEnum {

    /**
     * 1 按日期区间查询
     * 2 按接口流水号查询
     * 3 按交易交易号查询
     * 4 按交易条目号查询
     **/

    日期("1", "日期"),
    流水号("2", "流水号"),
    交易号("3", "交易号"),
    条目号("4", "条目号"),
    ;

    private static final Map<String, TradeQueryTypeEnum>
        codeMap = new HashMap<String, TradeQueryTypeEnum>();

    static {
        for (TradeQueryTypeEnum item : TradeQueryTypeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    private TradeQueryTypeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static TradeQueryTypeEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public TradeQueryTypeEnum getByWkCode(String code) {
        return getByCode(code);
    }

}
