/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: TradeTypeEnum.java, v 0.1 2019-06-20 20:22 bangis.wangdf Exp $
 */
public enum TradeTypeEnum implements WkEnum {

    /**
     * 001 放
     * 002 扣款
     **/

    放款("001", "放款"),
    扣款("002", "扣款"),
    ;

    private static final Map<String, TradeTypeEnum>
        codeMap = new HashMap<String, TradeTypeEnum>();

    static {
        for (TradeTypeEnum item : TradeTypeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    private TradeTypeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static TradeTypeEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public TradeTypeEnum getByWkCode(String code) {
        return getByCode(code);
    }
}