/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: WkAccountTypeEnum.java, v 0.1 2019-06-20 21:01 bangis.wangdf
 * Exp $
 */
public enum WkAccountTypeEnum implements WkEnum {
    /**
     * 0	支付平台账号
     * 1	个人借记卡
     * 2	企业账户
     * 3	个人信用卡
     **/

    支付平台账号("0", "支付平台账号"),
    个人借记卡("1", "个人借记卡"),
    企业账户("2", "企业账户"),
    个人信用卡("3", "个人信用卡"),

    ;

    private static final Map<String, WkAccountTypeEnum>
        codeMap = new HashMap();

    static {
        for (WkAccountTypeEnum item : WkAccountTypeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    WkAccountTypeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static WkAccountTypeEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public WkAccountTypeEnum getByWkCode(String code) {
        return getByCode(code);
    }

    /**
     * 枚举编码
     *
     * @return
     */
    @Override
    public String getCode() {
        return code;
    }

    /**
     * 枚举描述
     *
     * @return
     */
    @Override
    public String getDesc() {
        return desc;
    }
}
