/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * 账户类型
 *
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: WkAcctTypeEnum.java, v 0.1 2019-06-19 19:10 bangis.wangdf Exp $
 */
public enum WkAcctKindEnum implements WkEnum {
    /**
     * 01 为对公，02为对私
     **/

    对公("01", "对公"),
    对私("02", "对私"),

    ;

    private static final Map<String, WkAcctKindEnum>
        codeMap = new HashMap();

    static {
        for (WkAcctKindEnum item : WkAcctKindEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    WkAcctKindEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static WkAcctKindEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public WkAcctKindEnum getByWkCode(String code) {
        return getByCode(code);
    }

    /**
     * 枚举编码
     *
     * @return
     */
    @Override
    public String getCode() {
        return code;
    }

    /**
     * 枚举描述
     *
     * @return
     */
    @Override
    public String getDesc() {
        return desc;
    }
}
