/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 *
 * @author yangcheng
 * @version WkTradeStatusEnum.java, v0.12019-06-1815:42 yangchengExp$
 */
public enum WkAcctStatusEnum implements WkEnum {

    /**
     1	成功
     2	失败
     **/

    成功("1", "成功"),
    失败("2", "失败"),
    ;

    private static final Map<String, WkAcctStatusEnum>
            codeMap = new HashMap<String, WkAcctStatusEnum>();

    static {
        for (WkAcctStatusEnum item : WkAcctStatusEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    private WkAcctStatusEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }
    
    public static WkAcctStatusEnum getByCode(String code) {
        return codeMap.get(code);
    }
    
    @Override
    public String getCode() {
        return code;
    }
    
    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public WkAcctStatusEnum getByWkCode(String code) {
        return getByCode(code);
    }
}
