/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * 账户类型
 *
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: WkAcctTypeEnum.java, v 0.1 2019-06-19 19:10 bangis.wangdf Exp $
 */
public enum WkAcctTypeEnum implements WkEnum {
    /**
     * 1-放款账户,2-扣款账户,3-商户账户,4-费用账户,5-溢缴款账户
     **/

    放款账户("1", "放款账户"),
    扣款账户("2", "扣款账户"),
    商户账户("3", "商户账户"),
    费用账户("4", "费用账户"),
    溢缴款账户("5", "溢缴款账户"),

    ;

    private static final Map<String, WkAcctTypeEnum>
        codeMap = new HashMap();

    static {
        for (WkAcctTypeEnum item : WkAcctTypeEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    WkAcctTypeEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static WkAcctTypeEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public WkAcctTypeEnum getByWkCode(String code) {
        return getByCode(code);
    }

    /**
     * 枚举编码
     *
     * @return
     */
    @Override
    public String getCode() {
        return code;
    }

    /**
     * 枚举描述
     *
     * @return
     */
    @Override
    public String getDesc() {
        return desc;
    }
}
