/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.integration.wk.enums: WkAsynEnum.java, v 0.1 2019-06-18 14:19 bangis.wangdf Exp $
 */
public enum WkAsynEnum implements   WkEnum  {
    /**
     * ufc0000	支付平台
     * 000003	小微信贷系统
     **/

    否("0", "否"),
    是("1", "是"),

    ;

    private static final Map<String, WkAsynEnum>
        codeMap = new HashMap<String, WkAsynEnum>();

    static {
        for (WkAsynEnum item : WkAsynEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

      WkAsynEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static WkAsynEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public WkAsynEnum getByWkCode(String code) {
        return getByCode(code);
    }

}
