/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import com.abssqr.plat.common.model.exception.AbssqrBizException;
import com.general.system.common.util.VarChecker;

import java.util.HashMap;
import java.util.Map;

/**
 * @author yangcheng
 * @version WkChannelNoEnum.java, v0.12019-06-1815:54 yangchengExp$
 */
public enum WkChannelNoEnum implements WkEnum {
    BC_002("002", "工商银行"),
    BC_003("003", "农业银行"),
    BC_004("004", "中国银行"),
    BC_005("005", "建设银行"),
    BC_006("006", "交通银行"),
    BC_007("007", "招商银行"),
    BC_008("008", "中信银行"),
    BC_009("009", "浦发银行"),
    BC_010("010", "深圳发展银行"),
    BC_011("011", "兴业银行"),
    BC_012("012", "光大银行"),
    BC_014("014", "民生银行"),
    BC_015("015", "邮政储蓄"),
    BC_016("016", "北京银行"),
    BC_017("017", "华夏银行"),
    BC_018("018", "上海银行"),
    BC_019("019", "广发银行"),
    BC_020("020", "平安银行"),
    BC_021("021", "宁波银行"),
    BC_022("022", "上海农商银行"),
    BC_023("023", "北京农商"),
    BC_024("024", "青岛银行"),
    BC_025("025", "徽商银行"),
    BC_026("026", "浙商银行"),
    BC_027("027", "东莞银行"),
    BC_028("028", "杭州银行"),
    BC_029("029", "南京银行"),
    BC_030("030", "临商银行"),
    BC_031("031", "温州银行"),
    BC_032("032", "汉口银行"),
    BC_033("033", "江苏银行"),
    BC_034("034", "渤海银行"),
    BC_035("035", "张家港农商"),
    BC_036("036", "深圳农商行"),
    BC_037("037", "洛阳银行"),
    BC_038("038", "乌鲁木齐商行"),
    BC_039("039", "烟台银行"),
    BC_040("040", "齐商银行"),
    BC_041("041", "浙江民泰商业银行"),
    BC_042("042", "大连银行"),
    BC_043("043", "哈尔滨银行"),
    BC_044("044", "重庆银行"),
    BC_045("045", "浙江稠州商业银行"),
    BC_046("046", "东莞农商行"),
    BC_047("047", "天津银行"),
    BC_048("048", "河北银行"),
    BC_049("049", "嘉兴银行"),
    BC_050("050", "广州银行"),
    BC_051("051", "常熟农商行"),
    BC_052("052", "顺德农商行"),
    BC_053("053", "重庆农商行"),
    BC_054("054", "吴江农商行"),
    BC_055("055", "西安银行"),
    BC_056("056", "长沙银行"),
    BC_057("057", "江南农商行"),
    BC_058("058", "金华银行"),
    BC_059("059", "包商银行"),
    BC_060("060", "江阴农商行"),
    BC_061("061", "昆山农商行"),
    BC_062("062", "郑州银行"),
    BC_063("063", "厦门银行"),
    BC_064("064", "广州农商行"),
    BC_065("065", "华润银行"),
    BC_066("066", "华兴银行"),
    BC_801("801", "城市商业银行"),
    BC_802("802", "农村商业银行"),
    BC_803("803", "城市信用社"),
    BC_804("804", "农村信用社"),
    BC_805("805", "农村合作银行"),
    BC_CL0004("CL0004", "快钱"),
    BC_CL0001("CL0001", "中金"),
    BC_CL0008("CL0008", "兴业银行（银企直通车）"),
    BC_CL0005("CL0005", "宝付"),
    BC_CL0006("CL0006", "上银联"),
    BC_CL0002("CL0002", "广银联"),
    BC_CL0007("CL0007", "北京银联"),
    BC_CL0009("CL0009", "平安银行（银企直通车）"),
    BC_YQ0001("YQ0001", "招商银企"),
    
    ;
    
    private static final Map<String, WkChannelNoEnum>
            codeMap = new HashMap<String, WkChannelNoEnum>();
    
    static {
        for (WkChannelNoEnum item : WkChannelNoEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }
    
    private String code;
    private String desc;
    
    WkChannelNoEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }
    
    public static WkChannelNoEnum getByCode(String code) {
        return codeMap.get(code);
    }
    
    public static WkChannelNoEnum getPlatChannelNo(String code) {
        WkChannelNoEnum noEnum = getByCode(code);
        VarChecker.checkNotNull(noEnum,"找不到对应的五矿渠道[{0}]",code);
        switch (noEnum) {
            case BC_007:
                return BC_YQ0001;
            case BC_YQ0001:
                return noEnum;
            default:
                throw new AbssqrBizException("未配置对应虚拟账户");
        }
    }
    
    @Override
    public String getCode() {
        return code;
    }
    
    @Override
    public String getDesc() {
        return desc;
    }
    
    @Override
    public WkChannelNoEnum getByWkCode(String code) {
        return getByCode(code);
    }
}