/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

/**
 * @author yangcheng
 * @version PlatResultCodeEnum.java, v0.12019-06-1814:48 yangchengExp$
 */
public enum WkResultCodeEnum implements WkEnum {
    /**
     * 01-成功 02-失败 03-异常
     **/

    成功("01", "1", "成功"),
    失败("02", "2", "失败"),
    异常("03", "3", "异常"),
    ;

    private static final Map<String, WkResultCodeEnum>
        codeMap = new HashMap<String, WkResultCodeEnum>();

    static {
        for (WkResultCodeEnum item : WkResultCodeEnum.values()) {
            codeMap.put(item.getCode(), item);
            codeMap.put(item.getExtCode(), item);
        }
    }

    private String code;
    private String extCode;
    private String desc;

    WkResultCodeEnum(String code, String extCode, String desc) {
        this.code = code;
        this.extCode = extCode;
        this.desc = desc;
    }

    public static WkResultCodeEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public String getCode() {
        return code;
    }

    public String getExtCode() {
        return extCode;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public WkResultCodeEnum getByWkCode(String code) {
        return getByCode(code);
    }
}
