/**
 * abssqr.comInc.
 * Copyright(c)2019-2019AllRightsReserved.
 */
package com.abssqr.plat.common.integration.wk.enums;

import java.util.HashMap;
import java.util.Map;

import org.apache.commons.lang3.StringUtils;

/**
 * @author yangcheng
 * @version WkTradeStatusEnum.java, v0.12019-06-1815:42 yangchengExp$
 */
public enum WkTradeStatusEnum implements WkEnum {

    /**
     * 00000	未使用（仅返回链路状态时使用）
     * 1xxxx	成功
     * 2xxxx	处理中
     * 31xxx	失败-客户原因
     * 32xxx	失败-渠道原因
     * 33xxx	失败-支付系统原因
     * 39xxx	失败-未知失败原因
     * 9xxxx	支付平台异常
     **/

    成功("1", "成功"),
    处理中("2", "处理中"),
    失败_客户原因("31", "失败_客户原因"),
    失败_渠道原因("32", "失败_渠道原因"),
    失败_支付系统原因("33", "失败_支付系统原因"),
    失败_未知失败原因("39", "失败_未知失败原因"),
    支付平台异常("9", "支付平台异常"),
    ;

    private static final Map<String, WkTradeStatusEnum>
        codeMap = new HashMap<String, WkTradeStatusEnum>();

    static {
        for (WkTradeStatusEnum item : WkTradeStatusEnum.values()) {
            codeMap.put(item.getCode(), item);
        }
    }

    private String code;
    private String desc;

    WkTradeStatusEnum(String code, String desc) {
        this.code = code;
        this.desc = desc;
    }

    public static WkTradeStatusEnum getByCode(String code) {
        return codeMap.get(code);
    }

    @Override
    public String getCode() {
        return code;
    }

    @Override
    public String getDesc() {
        return desc;
    }

    @Override
    public WkTradeStatusEnum getByWkCode(String code) {
        for (WkTradeStatusEnum item : WkTradeStatusEnum.values()) {
            if (StringUtils.startsWith(code, item.code)) {
                return item;
            }
        }
        return getByCode(code);
    }
}
