/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.common.integration.wk.utils;

import java.lang.reflect.Field;

import cn.hutool.core.util.ReflectUtil;
import cn.hutool.core.util.XmlUtil;
import com.abssqr.plat.common.integration.wk.domain.Request;
import com.abssqr.plat.common.integration.wk.domain.Result;
import com.abssqr.plat.common.integration.wk.utils.converter.ElementConverters;
import org.w3c.dom.Document;
import org.w3c.dom.Element;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.common.model.wk.utils: XMLUtils.java, v 0.1 2019-06-18 16:23 bangis.wangdf Exp $
 */
public class XMLUtils {

    public static <T extends Result> T xmlToModel(String xml, T model, boolean uncapFirst) {
        Document document = XmlUtil.parseXml(xml);
        Field[] fields = ReflectUtil.getFields(model.getClass());
        Element rootElement = XmlUtil.getRootElement(document);
        for (Field field : fields) {
            String elemntName = ElementConverters.fileName(uncapFirst, field.getName());
            Element element = XmlUtil.getElement(rootElement, elemntName);
            if (field.getName().equals("header")) {
                ElementConverters.elementFillModel(element, model, field, model.getHeaderClazz(), uncapFirst);
            } else if (field.getName().equals("body")) {
                ElementConverters.elementFillModel(element, model, field, model.getBodyClazz(), uncapFirst);
            }
        }
        return model;
    }

    public static String modelToXml(Request wkPackage, boolean uncapFirst) {

        Field[] fields = ReflectUtil.getFields(wkPackage.getClass());
        String rootStr = ElementConverters.elementName(wkPackage, uncapFirst);

        Document root = XmlUtil.createXml(rootStr);
        for (Field field : fields) {

            String elemntName = ElementConverters.elementName(field, uncapFirst);
            Element element = ElementConverters.appendElement(root.getDocumentElement(), elemntName);
            ElementConverters.appendElement(element, ReflectUtil.getFieldValue(wkPackage, field), uncapFirst);
        }

        return XmlUtil.toStr(root, false);
    }

}
