/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.core.service.wk.pay;

import java.util.List;

import com.abssqr.plat.common.facade.enums.AccountAttributeEnum;
import com.abssqr.plat.common.facade.model.account.Account;
import com.abssqr.plat.common.integration.wk.domain.opr.request.acct.WkAccount;
import com.abssqr.plat.common.integration.wk.domain.qry.response.trade.TradeResult;
import com.abssqr.plat.common.integration.wk.enums.WkChannelNoEnum;
import com.abssqr.plat.common.util.base.autoconfig.AbsConfig;
import com.general.system.common.model.Money;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

/**
 * 支付管理 - 五矿支付
 *
 * @author bangis.wangdf
 * @version com.abssqr.plat.core.service.wk.pay: WkPayManager.java, v 0.1 2019-06-22 11:40 bangis.wangdf Exp $
 */
@Component
public class WkPayManager implements WkPayService {
    @Autowired
    AbsConfig absConfig;

    @Override
    public boolean project() {
        return getInstance(absConfig.getEnv()).project();
    }

    @Override
    public WkAccount createAccount(String planNo, String planName, AccountAttributeEnum actAttr) {
        return getInstance(absConfig.getEnv()).createAccount(planNo, planName, actAttr);
    }

    @Override
    public Money balance(String accountNo, WkChannelNoEnum channelNo) {
        return getInstance(absConfig.getEnv()).balance(accountNo, channelNo);
    }

    @Override
    public String trade(Account sourceAcct, Account targetAcct, Money money,String remark1) {
        return getInstance(absConfig.getEnv()).trade(sourceAcct, targetAcct, money,remark1);
    }

    @Override
    public TradeResult tradeRstQry(List<String> entryNos) {
        return getInstance(absConfig.getEnv()).tradeRstQry(entryNos);
    }
}