/**
 * abssqr.com Inc. 
 * Copyright (c) 2017-2019 All Rights Reserved. 
 */
package com.abssqr.plat.core.share.pay;

import com.abssqr.plat.common.facade.enums.PlanCapitalTransTypeEnum;
import com.general.system.common.model.BaseEntity;
import com.general.system.common.model.Money;

import java.util.Date;

/**
 * 计划资金交易请求
 * @author zhenxuan.luo
 * @version com.abssqr.plat.core.share.pay: PlanCapitalRequest.java, v 0.1 2019-06-03 16:46 zhenxuan.luo Exp $ 
 */
public class PlanCapitalCreateRequest extends BaseEntity {
    
    /**
     * 业务编号
     */
    private String                   bizNo;
    /**
     * 计划编号
     */
    private String                   planNo;
    /**
     * 目标机构编号
     */
    private String                   targetOrgCode;
    /**
     * 实付交易额
     */
    private Money                    transAmt = new Money(0);
    /**
     * payableAmt 应付金额.
     */
    private Money                    payableAmt = new Money(0);
    /**
     * 会计日期
     */
    private Date                     accountDate;
    /**
     * 资金交易类型
     */
    private PlanCapitalTransTypeEnum transType;
    /**
     * 备注
     */
    private String                   memo;
    
    public String getBizNo() {
        return bizNo;
    }
    
    public void setBizNo(String bizNo) {
        this.bizNo = bizNo;
    }
    
    public String getPlanNo() {
        return planNo;
    }
    
    public void setPlanNo(String planNo) {
        this.planNo = planNo;
    }
    
    public String getTargetOrgCode() {
        return targetOrgCode;
    }
    
    public void setTargetOrgCode(String targetOrgCode) {
        this.targetOrgCode = targetOrgCode;
    }
    
    public Money getTransAmt() {
        return transAmt;
    }
    
    public void setTransAmt(Money transAmt) {
        this.transAmt = transAmt;
    }
    
    public Date getAccountDate() {
        return accountDate;
    }
    
    public void setAccountDate(Date accountDate) {
        this.accountDate = accountDate;
    }
    
    public PlanCapitalTransTypeEnum getTransType() {
        return transType;
    }
    
    public void setTransType(PlanCapitalTransTypeEnum transType) {
        this.transType = transType;
    }
    
    public String getMemo() {
        return memo;
    }
    
    public void setMemo(String memo) {
        this.memo = memo;
    }
    
    public Money getPayableAmt() {
        return payableAmt;
    }
    
    public void setPayableAmt(Money payableAmt) {
        this.payableAmt = payableAmt;
    }
}