package com.abssqr.plat.test.testlink.ast;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Date;
import java.util.List;

import com.abssqr.plat.biz.shared.dispatcher.TaskGroupService;
import com.abssqr.plat.biz.shared.dispatcher.capitalAssetMatch.PlanCapitalAssertMatchExecutor;
import com.abssqr.plat.biz.shared.dispatcher.capitalAssetMatch.PlanCapitalAssertMatchLoader;
import com.abssqr.plat.biz.shared.dispatcher.match.PlanAstMatchDispatcherExecutor;
import com.abssqr.plat.biz.shared.dispatcher.match.PlanAstMatchDispatcherLoader;
import com.abssqr.plat.biz.shared.dispatcher.transfer.AstTrTaskExecutor;
import com.abssqr.plat.biz.shared.dispatcher.transfer.AstTrTaskLoader;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherExecutor;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherLoader;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherSplitor;
import com.abssqr.plat.biz.shared.scheduler.job.capitalAssertMatch.CapitalAssertMatchJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanDailyJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanFundJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanPackJob;
import com.abssqr.plat.biz.shared.scheduler.job.sync.ast.ZLOriginalAstSyncJob;
import com.abssqr.plat.common.dal.mysql.auto.dao.BizDataChangeDAO;
import com.abssqr.plat.common.dal.mysql.auto.dataobject.BizDataChangeDO;
import com.abssqr.plat.common.facade.enums.CommonTaskTypeEnum;
import com.abssqr.plat.common.facade.enums.PlanTypeEnum;
import com.abssqr.plat.common.facade.enums.TitleTypeEnum;
import com.abssqr.plat.common.facade.model.plan.PlanAcctTitle;
import com.abssqr.plat.common.facade.model.plan.PlanAlloc;
import com.abssqr.plat.common.facade.model.plan.PlanAllocItem;
import com.abssqr.plat.common.facade.param.org.OrgEntityOprParam;
import com.abssqr.plat.common.facade.param.plan.alloc.PlanAllocEditParam;
import com.abssqr.plat.common.facade.param.plan.alloc.PlanAllocQryParam;
import com.abssqr.plat.common.facade.param.plan.alloc.sub.PlanAllocItemParam;
import com.abssqr.plat.common.facade.service.plan.PlanAllocService;
import com.abssqr.plat.common.model.domain.task.CommonTask;
import com.abssqr.plat.common.model.domain.task.TrTask;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.common.model.repo.plan.PlanAcctTitleRepo;
import com.abssqr.plat.common.model.repo.plan.PlanAllocRepo;
import com.abssqr.plat.common.model.wk.domain.sync.WkMfsSyncCtr;
import com.abssqr.plat.common.util.base.autoconfig.AbsConfig;
import com.abssqr.plat.core.service.change.ChangeManager;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.plat.web.controller.org.OrgEntityController;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import com.general.system.bpm.domain.result.ProcessAfterResult;
import com.general.system.bpm.enums.ApproveStatusEnum;
import com.general.system.common.util.DateTimeUtil;
import com.general.system.common.util.LogUtil;
import com.general.system.core.common.constant.factory.ConstantFactory;
import com.google.common.collect.Lists;
import org.apache.commons.collections.CollectionUtils;
import org.apache.shiro.util.Assert;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

public class CapitalAstMatchTest extends BaseAutoTests{
    @Autowired
    private OrgEntityController            orgService;
    @Autowired
    private PlanFundJob                    planFundJob;
    @Autowired
    private PlanDailyJob                   planDailyJob;
    @Autowired
    private ChangeManager                  changeManager;
    @Autowired
    private PlanAllocService               planAllocService;
    @Autowired
    private WkMfsAstSyncDispatcherLoader   astSyncDispatcherLoader;
    @Autowired
    private WkMfsAstSyncDispatcherSplitor  astSyncDispatcherSplitor;
    @Autowired
    private WkMfsAstSyncDispatcherExecutor astSyncExecutor;
    @Autowired
    private BizDataChangeDAO               bizDataChangeDAO;
    @Autowired
    private AbsConfig                      absConfig;
    @Autowired
    ZLOriginalAstSyncJob zlOriginalAstSyncJob;

    @Autowired
    CapitalAssertMatchJob capitalAssertMathJob;

    @Autowired
    PlanCapitalAssertMatchLoader planCapitalAssertMatchLoader;

    @Autowired
    PlanCapitalAssertMatchExecutor planCapitalAssertMatchExecutor;

    @Autowired
    PlanAllocRepo planAllocRepo;

    @Autowired
    PlanAcctTitleRepo planAcctTitleRepo;

    @Autowired
    PlanPackJob planPackJob;

    @Autowired
    PlanAstMatchDispatcherLoader planAstMatchLoader;

    @Autowired
    PlanAstMatchDispatcherExecutor planAstMatchExecutor;
    @Autowired
    AstTrTaskExecutor astTrTaskExecutor;
    @Autowired
    AstTrTaskLoader astTrTaskLoader;
    @XTest(relatePath = "testlink/ast/capitalAstMatch/plan")
    @Test(dataProvider = "YamlDataProvider", description = "创建并生效放款计划", priority = 1)
    public void createPlanTestLink(ICase iCase, String acctDate, OrgEntityOprParam spvParam) {
        super.validJobCtr(capitalAssertMathJob.getJobName());

        ConstantFactory.me().securityLogin("administrator");

        // 更新会计日期
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        try {
            // 首次设置会计日期为 项目成立日期 -1
            Date strDate = format.parse(acctDate);
            super.updateDate(strDate, OrgCodeEnum.ABS.getCode());

            // 放款计划管理--------------------------------------------
            orgService.edit(spvParam);

            BizDataChangeDO spvBizData = bizDataChangeDAO.getByBizNoAndStatus(spvParam.getPlanNo(), "PENDING");
            if(spvBizData != null) {
                // 审批-->创建水位与科目
                ProcessAfterResult spvRes = new ProcessAfterResult();
                spvRes.setBusinessKey(spvBizData.getChangeNo());
                spvRes.setStatusEnum(ApproveStatusEnum.PASSED);
                changeManager.handle(spvRes);
            }

            // 生成默认分配计划
            PlanAllocQryParam allocSpvParm = new PlanAllocQryParam();
            allocSpvParm.setPlanNo(spvParam.getPlanNo());
            planAllocService.getPlanAlloc(allocSpvParm);

            // 投入资本到账--------------------------------------------

            // 再次设置会计日期为 项目起息日
            super.updateDate(DateTimeUtil.addDays(strDate, 1), OrgCodeEnum.ABS.getCode());

            planDailyJob.doExecute();

        } catch (ParseException e) {
            throw new RuntimeException(e.getMessage());
        }
    }

    //testOnly不要删除，testOnly是按照顺序执行
    //@XTest(relatePath = "testlink/ast/capitalAstMatch/initData", testOnly={"initWKData_capitalAstMatch_case0001","initWKData_capitalAstMatch_case0002"})
    @XTest(relatePath = "testlink/ast/capitalAstMatch/initData")
    @Test(dataProvider = "YamlDataProvider", description = "同步五矿数据-初始化", priority = 2)
    public void capitalAstMatchTest(ICase iCase, String acctDate,boolean unMatch,String spvNo,String orgCode,String layerNo,Integer allocAmt,boolean needTrans) {

        absConfig.setWkxwDbName("mfsbaid");
        absConfig.setWkxwSynonymPre(".");
        absConfig.setWkxwRepayPlanSelf(true);

        // 更新会计日期
        DateFormat format = new SimpleDateFormat("yyyyMMdd");
        LogUtil.info(logger, " ---- 查询数据");
        try {
            Date strDate = format.parse(acctDate);
            super.updateDate(strDate, orgCode);

            //PlanBase plan = planRepo.getPlanByNo(planNo);
            //PlanBase spv = planRepo.getPlanByNo(spvNo);

            // ----每日任务----
            LogUtil.info(logger, " ---- 1 初始化水位");

            // 调用接口-初始化水位
            planFundJob.doExecute();

            // 计划每日任务
            LogUtil.info(logger, " ---- 2 计划每日任务");
            //planDailyJob.doExecute();

            // ----同步五矿数据----
            zlOriginalAstSyncJob.doExecute();

            LogUtil.info(logger, " ---- 3 同步五矿数据");

//            astSyncDispatcherSplitor.setOrgCode(orgCode);

//            astSyncDispatcherLoader.setOrgCode(orgCode);
            List<WkMfsSyncCtr> syncNodes = astSyncDispatcherLoader.loadToDoNodes(
                    new TaskGroupService() {
                        @Override
                        public List getTasks() {
                            return  Lists.newArrayList(1L,Long.MAX_VALUE);
                        }

                        @Override
                        public void finish() {

                        }
                    }
                    , new TaskGroupService() {
                        @Override
                        public List getTasks() {
                            return Lists.newArrayList();
                        }

                        @Override
                        public void finish() {

                        }
                    }
                    , 20);
            for (WkMfsSyncCtr syncNode : syncNodes) {
                astSyncExecutor.doExecute(syncNode);
            }
            //所有同步数据处理完成后，更新任务为成功
            astSyncDispatcherSplitor.split();

            //生成同步解绑任务
            capitalAssertMathJob.doExecute();
            //执行解绑/解绑匹配操作
            List<CommonTask> commonTasks = planCapitalAssertMatchLoader.loadToDoNodes(100);
            for(CommonTask commonTask:commonTasks){
                planCapitalAssertMatchExecutor.execute(commonTask);
            }
            //申请兑付

            if(unMatch){
                List<PlanAlloc> planAllocs = planAllocRepo.queryByPlanNo(spvNo);
                Assert.notEmpty(planAllocs,"放款计划"+spvNo+"不存在默认的分配计划");
                PlanAlloc planAlloc = planAllocs.get(0);
                PlanAllocEditParam planAllocEditParam = buildPlanAllocEditParam(planAlloc,spvNo,layerNo,allocAmt);
                PlanTypeEnum planType = PlanTypeEnum.getByCode("SPV");
                planAllocService.edit(planAllocEditParam, planType, true);
                PlanAlloc planAllocDetail = planAllocRepo.getPlanAllocDetail(planAlloc.getAllocNo());
                planAllocDetail.setApproveStatus(ApproveStatusEnum.PASSED);
                planAllocRepo.addOrUpdate(planAllocDetail,true);
                //生成 解绑/匹配 任务
                capitalAssertMathJob.doExecute();
                Thread.sleep(1000);
                //执行解绑/解绑匹配操作
                List<CommonTask> commonTasks2 = planCapitalAssertMatchLoader.loadToDoNodes(100);
                for(CommonTask commonTask:commonTasks2){
                    planCapitalAssertMatchExecutor.execute(commonTask);
                }

            }
            if(needTrans){
                // 筛选资产包创建
                LogUtil.info(logger, " ---- 4 筛选资产包创建");
                planPackJob.doExecute();

                // ----资产转让----
                // 资产筛选
                LogUtil.info(logger, " ---- 5 资产筛选");
                planAstMatchLoader.setSleepTime(0);
                List<CommonTask> commonTask = planAstMatchLoader.loadToDoNodes(10);
                for(CommonTask task: commonTask){
                    if(task.getTaskType().equals(CommonTaskTypeEnum.PACK_MATCH)){
                        planAstMatchExecutor.doExecute(task);
                    }
                }

                // 资产转让
                LogUtil.info(logger, " ---- 6 资产转让");
                List<TrTask> trTasks = astTrTaskLoader.loadToDoNodes(10);
                for (TrTask trTask : trTasks) {
                    astTrTaskExecutor.doExecute(trTask);
                }
            }

        } catch (Exception e) {
            System.out.println(e.getMessage());
            e.printStackTrace();
            throw new RuntimeException(e.getMessage());
        } finally {
            checkDB(iCase);
            clearDB(iCase);
        }

    }
    //科目三兑付2500所有的资产全部兑付

    private PlanAllocEditParam buildPlanAllocEditParam(PlanAlloc planAlloc,String spvNo,String layerNo,Integer allocAmt){
        List<PlanAcctTitle> planAcctTitles = planAcctTitleRepo.getByEntityNo(spvNo);
        PlanAcctTitle planAcctTitle= planAcctTitles.stream()
                .filter(v->v.getTitleType()== TitleTypeEnum.PRIOR_INVESTED)
                .filter(v->spvNo.equals(v.getPlanNo()))
                .filter(v->layerNo.equals(v.getRefNo()))
                .findFirst().get();
        List<PlanAllocItem> planAllocItemList = planAlloc.getPlanAllocItemList();
        List<PlanAllocItemParam> planAllocItemParams=new ArrayList<>();
        if(CollectionUtils.isNotEmpty(planAllocItemList)){
            PlanAllocItem planAllocItem = planAllocItemList.get(0);
            PlanAllocItemParam planAllocItemParam=new PlanAllocItemParam();
            planAllocItemParam.setTax(planAllocItem.getTax());
            planAllocItemParam.setTitleNo(planAcctTitle.getTitleNo());
            planAllocItemParam.setConfirmAmt(allocAmt.toString());
            planAllocItemParam.setConfirmTaxAmt(planAllocItem.getTrialTaxAmt().getAmount().toPlainString());
            planAllocItemParam.setTrialAmt(planAllocItem.getTrialAmt().getAmount().toPlainString());
            planAllocItemParam.setTrialTaxAmt(planAllocItem.getTrialTaxAmt().getAmount().toPlainString());
            planAllocItemParam.setOrder(planAllocItem.getOrder());
            planAllocItemParams.add(planAllocItemParam);
            planAllocItem.setConfirmAmt(planAllocItem.getTrialAmt());
            planAllocItem.setConfirmTaxAmt(planAllocItem.getTrialTaxAmt());
        }

        PlanAllocEditParam planAllocEditParam=new PlanAllocEditParam();
        planAllocEditParam.setPlanNo(planAlloc.getPlanNo());
        planAllocEditParam.setAllocNo(planAlloc.getAllocNo());
        planAllocEditParam.setPlanAllocItemParamList(planAllocItemParams);
        return planAllocEditParam;
    }
    //是否发生转让

}
