package com.abssqr.plat.test.testlink.plan;

import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanAstStatJob;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

public class PlanAstStatJobNormalTest extends BaseAutoTests {
    
    @Autowired
    private PlanAstStatJob planAstStatJob;
    
    @XTest(relatePath = "testlink/plan/planAstStatJob")
    @Test(dataProvider = "YamlDataProvider", description = "计划资产状态汇总")
    public void stateJob(ICase iCase, String acctDate) {
        
        try {
            super.updateDate(acctDate, OrgCodeEnum.ABS.getCode());
            // 执行任务
            planAstStatJob.doExecute();
            
        } finally {
            // 校验数据
            checkDB(iCase);
            super.clearDB(iCase);
        }
        
    }
}
