package com.abssqr.plat.test.testlink.plan;

import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanFundJob;
import com.abssqr.plat.common.dal.mysql.auto.dao.AcctDateDAO;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.common.util.base.autoconfig.AbsConfig;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

public class PlanFundJobNormalTest extends BaseAutoTests {

    @Autowired
    private PlanFundJob planFundJob;

    @Autowired
    private AcctDateDAO acctDateDAO;
    @Autowired
    private AbsConfig absConfig;

    @XTest(relatePath = "testlink/plan/planFundJob")
    @Test(dataProvider = "YamlDataProvider", description = "资金到账任务")
    public void planFundJob(ICase iCase, String acctDate) {

        // 更新会计日期
        absConfig.setEnv("fun_test");

        try {
            super.updateDate(acctDate, OrgCodeEnum.ABS.getCode());

            // 根据环境统一设置mock，默认mock金额为10000000000

            // 调用接口
            planFundJob.doExecute();

        } finally {
            // 校验数据
            super.checkDB(iCase);
            super.clearDB(iCase);
        }

    }
}
