package com.abssqr.plat.test.testlink.plan;

import com.abssqr.plat.biz.shared.dispatcher.TaskGroupService;
import com.abssqr.plat.biz.shared.dispatcher.match.PlanAstMatchDispatcherExecutor;
import com.abssqr.plat.biz.shared.dispatcher.match.PlanAstMatchDispatcherLoader;
import com.abssqr.plat.biz.shared.dispatcher.transfer.AstTrTaskExecutor;
import com.abssqr.plat.biz.shared.dispatcher.transfer.AstTrTaskLoader;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherExecutor;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherLoader;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherSplitor;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherStarter;
import com.abssqr.plat.biz.shared.dispatcher.wkPlanReport.PlanReportTaskExecutor;
import com.abssqr.plat.biz.shared.dispatcher.wkPlanReport.PlanReportTaskLoader;
import com.abssqr.plat.biz.shared.handler.PlanAstClearingOrderHandler;
import com.abssqr.plat.biz.shared.handler.PlanAstClearingStatHandler;
import com.abssqr.plat.biz.shared.handler.PlanAstStatTaskHandler;
import com.abssqr.plat.biz.shared.handler.PlanFundHandler;
import com.abssqr.plat.biz.shared.scheduler.job.ast.ZLFinSerFeeJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanDailyJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanFundJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanPackJob;
import com.abssqr.plat.biz.shared.scheduler.job.sync.ast.ZLOriginalAstSyncJob;
import com.abssqr.plat.common.dal.mysql.auto.dao.BizDataChangeDAO;
import com.abssqr.plat.common.dal.mysql.auto.dataobject.BizDataChangeDO;
import com.abssqr.plat.common.facade.enums.CommonTaskTypeEnum;
import com.abssqr.plat.common.facade.enums.OrgAstStatStatusEnum;
import com.abssqr.plat.common.facade.model.plan.PlanBase;
import com.abssqr.plat.common.facade.model.plan.PlanCapitalOrder;
import com.abssqr.plat.common.facade.param.org.OrgEntityOprParam;
import com.abssqr.plat.common.facade.param.plan.PlanOprParam;
import com.abssqr.plat.common.facade.param.plan.alloc.PlanAllocQryParam;
import com.abssqr.plat.common.facade.service.plan.PlanAllocService;
import com.abssqr.plat.common.facade.service.plan.PlanService;
import com.abssqr.plat.common.model.domain.job.JobControl;
import com.abssqr.plat.common.model.domain.plan.PlanAstStatTask;
import com.abssqr.plat.common.model.domain.task.CommonTask;
import com.abssqr.plat.common.model.domain.task.TrTask;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.common.model.repo.ast.PlanAstStatTaskRepo;
import com.abssqr.plat.common.model.repo.plan.PlanCapitalOrderRepo;
import com.abssqr.plat.common.model.repo.plan.PlanRepo;
import com.abssqr.plat.common.model.wk.domain.sync.WkMfsSyncCtr;
import com.abssqr.plat.common.util.base.Day;
import com.abssqr.plat.common.util.base.autoconfig.AbsConfig;
import com.abssqr.plat.core.service.accounting.OrgAcctDayComponent;
import com.abssqr.plat.core.service.change.ChangeManager;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.plat.web.controller.org.OrgEntityController;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import com.general.system.bpm.domain.result.ProcessAfterResult;
import com.general.system.bpm.enums.ApproveStatusEnum;
import com.general.system.common.util.DateTimeUtil;
import com.general.system.common.util.LogUtil;
import com.general.system.core.common.constant.factory.ConstantFactory;
import com.general.system.tool.util.ToolUtil;
import com.google.common.collect.Lists;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.text.DateFormat;
import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.List;

//@ActiveProfiles("dev")
public class PlanReportNormalTest extends BaseAutoTests {
    @Autowired
    private     PlanService                    planService;
    @Autowired
    private     OrgEntityController            orgService;
    @Autowired
    private     PlanFundJob                    planFundJob;
    @Autowired
    private     PlanDailyJob                   planDailyJob;
    @Autowired
    private     PlanReportTaskExecutor         reportExecutor;
    @Autowired
    private ChangeManager                   changeManager;
    @Autowired
    private AstTrTaskLoader                 astTrTaskLoader;
    @Autowired
    private PlanFundHandler                planFundHandler;
    @Autowired
    private PlanRepo                       planRepo;
    @Autowired
    private PlanAllocService               planAllocService;
    @Autowired
    private PlanAstMatchDispatcherLoader   planAstMatchLoader;
    @Autowired
    private PlanAstMatchDispatcherExecutor planAstMatchExecutor;
    @Autowired
    private AstTrTaskExecutor              astTrTaskExecutor;
    @Autowired
    private PlanAstStatTaskRepo            planAstStatTask;
    @Autowired
    private PlanAstClearingStatHandler     planAstStatHandler;
    @Autowired
    private WkMfsAstSyncDispatcherLoader   astSyncDispatcherLoader;
    @Autowired
    private WkMfsAstSyncDispatcherSplitor  astSyncDispatcherSplitor;
    @Autowired
    private WkMfsAstSyncDispatcherExecutor astSyncExecutor;
    @Autowired
    private WkMfsAstSyncDispatcherStarter  astSyncStarter;
    @Autowired
    private BizDataChangeDAO            bizDataChangeDAO;
    @Autowired
    private ZLFinSerFeeJob              zlFinSerFeeJob;
    @Autowired
    private PlanAstStatTaskHandler      planAstStatTaskHandler;
    @Autowired
    private PlanCapitalOrderRepo        planCapitalOrderRepo;
    @Autowired
    private PlanReportTaskLoader        planLoader;
    @Autowired
    private PlanAstClearingOrderHandler planAstClearingOrderHandler;
    @Autowired
    private PlanPackJob                 planPackJob;
    @Autowired
    private OrgAcctDayComponent         orgAcctDayComponent;
    @Autowired
    private AbsConfig                   absConfig;
    @Autowired
    ZLOriginalAstSyncJob zlOriginalAstSyncJob;

    @XTest(relatePath = "testlink/plan/planReport")
    @Test(dataProvider = "YamlDataProvider", description = "创建并生效计划", priority = 1)
    public void createPlanTestLink(ICase iCase, String acctDate, String planCash, PlanOprParam planParam, OrgEntityOprParam spvParam) {

        ConstantFactory.me().securityLogin("administrator");

        // 更新会计日期
        DateFormat format = new SimpleDateFormat("yyyy-MM-dd");
        try {
            // 首次设置会计日期为 项目成立日期 -1
            Date strDate = format.parse(acctDate);
            super.updateDate(strDate, OrgCodeEnum.ABS.getCode());

            // 受让计划管理-->提交审批
            LogUtil.info(logger, " ---- 1 计划初始化");
            planService.edit(planParam);

            BizDataChangeDO bizData = bizDataChangeDAO.getByBizNoAndStatus(planParam.getPlanNo(), "PENDING");
            if (bizData != null) {
                // 审批-->创建水位与科目
                ProcessAfterResult result = new ProcessAfterResult();
                result.setBusinessKey(bizData.getChangeNo());
                result.setStatusEnum(ApproveStatusEnum.PASSED);
                changeManager.handle(result);
            }

            // 生成默认分配计划
            LogUtil.info(logger, " ---- 3 生成默认分配计划");
            PlanAllocQryParam allocParm = new PlanAllocQryParam();
            allocParm.setPlanNo(planParam.getPlanNo());
            planAllocService.getPlanAlloc(allocParm);

            // 放款计划管理--------------------------------------------
            orgService.edit(spvParam);

            BizDataChangeDO spvBizData = bizDataChangeDAO.getByBizNoAndStatus(spvParam.getPlanNo(), "PENDING");
            if(spvBizData != null) {
                // 审批-->创建水位与科目
                ProcessAfterResult spvRes = new ProcessAfterResult();
                spvRes.setBusinessKey(spvBizData.getChangeNo());
                spvRes.setStatusEnum(ApproveStatusEnum.PASSED);
                changeManager.handle(spvRes);
            }

            // 生成默认分配计划
            PlanAllocQryParam allocSpvParm = new PlanAllocQryParam();
            allocSpvParm.setPlanNo(spvParam.getPlanNo());
            planAllocService.getPlanAlloc(allocSpvParm);

            // 投入资本到账--------------------------------------------

            // 再次设置会计日期为 项目起息日
            super.updateDate(DateTimeUtil.addDays(strDate, 1), OrgCodeEnum.ABS.getCode());

            planDailyJob.doExecute();

            // 初始化水位，根据环境统一设置mock，默认mock金额为10000000000

            // 执行余额查询
            LogUtil.info(logger, " ---- 2 执行余额查询");
            PlanBase planEntity = planRepo.getPlanByNo(planParam.getPlanNo());
            planFundHandler.executeQueryBalance(planEntity, new Day(strDate).getTomorrow());

            // 校验数据
            checkDB(iCase);

        } catch (ParseException e) {
            e.printStackTrace();
        }
    }

    //testOnly不要删除，testOnly是按照顺序执行
    @XTest(relatePath = "testlink/baseData1", testOnly={"initWKData_20190703","initWKData_20190704"})
    @Test(dataProvider = "YamlDataProvider", description = "同步五矿数据-初始化", priority = 1)
    public void dailyJobTest(ICase iCase, String acctDate, String planNo, String spvNo, String orgCode) {

        absConfig.setWkxwDbName("mfsbaid");
        absConfig.setWkxwSynonymPre(".");
        absConfig.setWkxwRepayPlanSelf(true);

        LogUtil.info(logger, " ---- 查询数据");
        
        String astSyncStarterCtrl = astSyncStarter.getName();
        JobControl astSyncCtrl = invalidJobCtr(astSyncStarterCtrl);
        String trTaskStarterCtrl = astSyncStarter.getName();
        JobControl trTaskCtrl = invalidJobCtr(trTaskStarterCtrl);

        try {
            Day strDate = new Day(acctDate);
            // 更新会计日期
            super.updateDate(strDate.getTomorrow().getStandardDate(), OrgCodeEnum.ABS.getCode());
            // 对应机构日
            super.updateDate(strDate.getStandardDate(), orgCode);
            
            PlanBase plan = planRepo.getPlanByNo(planNo);
            PlanBase spv = planRepo.getPlanByNo(spvNo);
            
            // ----每日任务----
            LogUtil.info(logger, " ---- 1 初始化水位");

            // 调用接口-初始化水位
            planFundJob.doExecute();
            
            // 计划每日任务
            LogUtil.info(logger, " ---- 2 计划每日任务");
            planDailyJob.doExecute();

            // ----同步五矿数据----
             zlOriginalAstSyncJob.doExecute();

            LogUtil.info(logger, " ---- 3 同步五矿数据");
//            astSyncDispatcherLoader.setOrgCode(orgCode);

            List<WkMfsSyncCtr> syncNodes = astSyncDispatcherLoader.loadToDoNodes(
                    new TaskGroupService() {
                        @Override
                        public List getTasks() {
                            return  Lists.newArrayList(1L, 9999999L);
                        }

                        @Override
                        public void finish() {

                        }
                    }
                    , new TaskGroupService() {
                        @Override
                        public List getTasks() {
                            return Lists.newArrayList();
                        }

                        @Override
                        public void finish() {

                        }
                    }
                    , 20);
            for (WkMfsSyncCtr syncNode : syncNodes) {
                astSyncExecutor.doExecute(syncNode);
            }
//            astSyncDispatcherSplitor.setOrgCode(orgCode);
            //所有同步数据处理完成后，更新任务为成功
            astSyncDispatcherSplitor.split();


            // 筛选资产包创建
            LogUtil.info(logger, " ---- 4 筛选资产包创建");
            planPackJob.doExecute();

            // ----资产转让----
            // 资产筛选
            LogUtil.info(logger, " ---- 5 资产筛选");
            planAstMatchLoader.setSleepTime(0);
            List<CommonTask> commonTask = planAstMatchLoader.loadToDoNodes(10);
            for(CommonTask task: commonTask){
                if(task.getTaskType().equals(CommonTaskTypeEnum.PACK_MATCH)){
                    planAstMatchExecutor.doExecute(task);
                }
            }

            // 资产转让
            LogUtil.info(logger, " ---- 6 资产转让");
            List<TrTask> trTasks = astTrTaskLoader.loadToDoNodes(10);
            for (TrTask trTask : trTasks) {
                astTrTaskExecutor.doExecute(trTask);
            }

            // 金融服务费定时任务统计
            LogUtil.info(logger, " ---- 6.1 金融服务费定时任务统计");
            zlFinSerFeeJob.setZlOrgCode("1009");
            zlFinSerFeeJob.doExecute();
    
            // 清算
            // 计划资产状态汇总
            LogUtil.info(logger, " ---- 7 清算汇总");
            planAstStatTaskHandler.handle(planNo, strDate);
            planAstStatTaskHandler.handle(spvNo, strDate);
    
            PlanAstStatTask astStatTask1 = planAstStatTask.getPlanNo(planNo);
            if (astStatTask1 != null) {
                astStatTask1.setStatus(OrgAstStatStatusEnum.PROCESS);
                astStatTask1.setMinId(null);
                planAstStatTask.updateTask(astStatTask1);
                planAstStatHandler.execute(astStatTask1, "999912312359");
            }
            PlanAstStatTask astStatTask2 = planAstStatTask.getPlanNo(spvNo);
            if (astStatTask2 != null) {
                planAstStatHandler.execute(astStatTask2, "999912312359");
                astStatTask2.setAccountDate(strDate.getStandardDate());
                astStatTask2.setMinId(null);
                astStatTask2.setStatus(OrgAstStatStatusEnum.PROCESS);
                planAstStatTask.updateTask(astStatTask2);
                planAstStatHandler.execute(astStatTask2, "999912312359");
            }
    
            // 结算任务处理
            LogUtil.info(logger, " ---- 8 结算处理");
            planAstClearingOrderHandler.handle(plan);
            planAstClearingOrderHandler.handle(spv);
    
            // wk交易调用
            // 资金订单状态由wait-->succ， 记得修改next_exec_time <= sysdate
            LogUtil.info(logger, " ---- 9 支付处理");
            List<PlanCapitalOrder> capitalOrders = planCapitalOrderRepo.getInitListByPlanNo(planNo);
            capitalOrders.addAll(planCapitalOrderRepo.getInitListByPlanNo(spvNo));
            super.capitalOrderMock(capitalOrders);
    
            // 放款池可能会有回转放的结算单需要执行
            planAstClearingOrderHandler.handle(spv);
            List<PlanCapitalOrder> spvReturn = planCapitalOrderRepo.getInitListByPlanNo(spv.getPlanNo());
            super.capitalOrderMock(spvReturn);
    
            
            // 计划报表
            LogUtil.info(logger, " ---- 11 计划报表");
            List<CommonTask> tasks = planLoader.loadToDoNodes(20);
            LogUtil.info(logger, " ---- 当前用例：" + iCase.getId() + "----");
            while (tasks.size() > 0){

                LogUtil.info(logger, " ---- 执行报表任务：");
                for(CommonTask task: tasks){
                    if(ToolUtil.equals(task.getContext(), "lenderCode001")){
                        LogUtil.info(logger, " ---- 执行放款池计划报表任务：");
                        reportExecutor.doExecute(task);
                    }
                }


                for(CommonTask task: tasks){
                    if(ToolUtil.equals(task.getContext(), "testTrustPlanNo001")){
                        LogUtil.info(logger, " ---- 执行受让池计划报表任务：");
                        reportExecutor.doExecute(task);
                    }
                    
                }
    
                tasks = planLoader.loadToDoNodes(20);
            }

        } catch (Throwable e) {
            e.getMessage();
            e.printStackTrace();
        } finally {
//            validJobCtr(astSyncCtrl);
//            validJobCtr(trTaskCtrl);
            checkDB(iCase);
//            super.clearDB(iCase);

        }

    }

}
