/**
 * abssqr.com Inc. 
 * Copyright (c) 2017-2019 All Rights Reserved. 
 */
package com.abssqr.plat.test.unittest.job;

import com.abssqr.plat.biz.shared.scheduler.job.plan.LenderOrgCapitalJob;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.text.ParseException;

/**
 *
 * @author hanfei
 * @version $Id: LenderOrgCapitalJobTest.java, v 0.1 2019-12-13 7:29 PM hanfei Exp $
 */
public class LenderOrgCapitalJobTest extends BaseAutoTests {

    @Autowired
    private LenderOrgCapitalJob lenderOrgCapitalJob;
    
    @XTest(relatePath = "unittest/job/LenderOrgCapital")
    @Test(dataProvider = "YamlDataProvider", description = "放款户转还款户 ")
    public void jobTest(ICase iCase, String strDate) throws ParseException {
        
        try {
            // 更新会计日期
            super.updateDate(strDate, OrgCodeEnum.ABS.getCode());
            
            lenderOrgCapitalJob.doExecute();
    
    
        } finally {
            // 校验数据
            super.checkDB(iCase);
            super.clearDB(iCase);
        }
    }
}
