/**
 * abssqr.com Inc. 
 * Copyright (c) 2017-2019 All Rights Reserved. 
 */
package com.abssqr.plat.test.unittest.job;

import com.abssqr.plat.biz.shared.handler.PlanAstClearingStatHandler;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanAstStatJob;
import com.abssqr.plat.common.model.domain.plan.PlanAstStatTask;
import com.abssqr.plat.common.model.repo.ast.PlanAstStatTaskRepo;
import com.abssqr.plat.core.service.system.TimeStampUtil;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import com.general.system.common.util.SystemDateUtil;
import com.google.common.collect.Lists;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

/**
 *  清算流水汇总
 * @author hanfei
 * @version $Id: PlanAstClearingOrderJobTest.java, v 0.1 2019-09-12 5:56 PM hanfei Exp $ 
 */
//@ActiveProfiles("dev")
public class PlanAstClearLogStatTest extends BaseAutoTests {
    @Autowired
    private PlanAstClearingStatHandler planAstClearingStatHandler;
    @Autowired
    private PlanAstStatTaskRepo        planAstStatTaskRepo;
    @Autowired
    private PlanAstStatJob             planAstStatJob;
    
    @XTest(relatePath = "unittest/job/clearLog")
    @Test(dataProvider = "YamlDataProvider", description = "测试结算单处理逻辑")
    public void clearingOrder(ICase iCase, String planNo) {

        try {

            int count = planAstStatTaskRepo.updateTaskExec(SystemDateUtil.getSystemDate(),
                    "test",
                    Lists.newArrayList(planNo));

            PlanAstStatTask node = planAstStatTaskRepo.getPlanNo(planNo);
            String execTms = TimeStampUtil.getCurrentBufferedTimestamp();
            planAstClearingStatHandler.execute(node, execTms);
    
//            // 执行切换
//            planAstStatJob.execute(null);
//            planAstStatTaskRepo.updateTaskExec(SystemDateUtil.getSystemDate(),
//                    "test",
//                    Lists.newArrayList(planNo));
//            node = planAstStatTaskRepo.getPlanNo(planNo);
//            execTms = TimeStampUtil.getCurrentBufferedTimestamp();
//            planAstClearingStatHandler.execute(node, execTms);
        } finally {
            // 校验数据
            checkDB(iCase);
            super.clearDB(iCase);
        }
    }
}
