/**
 * abssqr.com Inc. 
 * Copyright (c) 2017-2019 All Rights Reserved. 
 */
package com.abssqr.plat.test.unittest.job;

import com.abssqr.plat.biz.shared.handler.PlanAstClearingOrderHandler;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanAstClearingOrderJob;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

/**
 *
 * @author hanfei
 * @version $Id: PlanAstClearingOrderJobTest.java, v 0.1 2019-09-12 5:56 PM hanfei Exp $ 
 */
public class PlanAstClearingOrderJobTest extends BaseAutoTests {
    @Autowired
    private PlanAstClearingOrderJob     planAstClearingOrderJob;
    @Autowired
    private PlanAstClearingOrderHandler planAstClearingOrderHandler;
    
    @XTest(relatePath = "unittest/job/clearingOrder")
    @Test(dataProvider = "YamlDataProvider", description = "测试结算单处理逻辑")
    public void clearingOrder(ICase iCase) {
        /**
         * 测试结算单处理场景
         * 1、放款池计划
         *  1.1 放款终止日 停止支付 当交易单据类型资金流出 并且 停止支付时 只更新结算单状态 不进行支付操作
         *  1.2 未转让交易 资金流入时 增加水位 -- 可交易金额大于零 -- 水位金额cover 交易金额
         *  1.3 未转让交易 资金流入时 增加水位 -- 可交易金额小于零 -- 水位余额不足 直接将结算单更新为, 成功 SUCCESS
         *  1.4 未转让交易 资金流入时 增加水位 -- 可交易金额大于零 -- 当实际交易金额小于结算单交易金额进行拆支付交易单
         *  1.5 支付应付利息-放款冲正-购买资产-回转放的结算单处理
         * 2、受让池计划
         *  1.1 未转让交易 资金流入时 增加水位 -- 可交易金额大于零 -- 水位金额cover 交易金额
         *  1.2 未转让交易 资金流入时 增加水位 -- 可交易金额大于零 -- 当实际交易金额小于结算单交易金额进行拆支付交易单
         *  1.3 未转让交易 资金流入时 增加水位 -- 水位余额不足 直接将结算单更新为 成功 SUCCESS
         */
        try {
            planAstClearingOrderJob.doExecute();
//        planAstClearingOrderHandler.handle();

        
        } finally {
            // 校验数据
            checkDB(iCase);
            super.clearDB(iCase);
        }
    }
}
