/**
 * abssqr.com Inc. 
 * Copyright (c) 2017-2019 All Rights Reserved. 
 */
package com.abssqr.plat.test.unittest.job;

import com.abssqr.plat.common.facade.model.plan.PlanCapitalOrder;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.common.model.repo.plan.PlanCapitalOrderRepo;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.util.List;

/**
 * 资金交易单查询结果 认为调整支付单金额 水位金额校验异常
 * @author hanfei
 * @version $Id: PlanCapitalOrderResErrorJobTest.java, v 0.1 2019-09-06 11:26 AM hanfei Exp $
 */
public class PlanCapitalOrderResErrorJobTest extends BaseAutoTests {
    
    @Autowired
    private PlanCapitalOrderRepo        planCapitalOrderRepo;
    
    @XTest(relatePath = "unittest/job/capitalOrderRes/error")
    @Test(dataProvider = "YamlDataProvider", description = "认为修改支付单金额交易单查询结果执行失败")
    public void capitalOrder(ICase iCase, String planNo, String acctDate) {
        try {
            super.updateDate(acctDate, OrgCodeEnum.ABS.getCode());

            // 资金订单状态由wait-->succ， 记得修改next_exec_time <= sysdate
            List<PlanCapitalOrder> capitalOrders = planCapitalOrderRepo.getInitListByPlanNo(planNo);
            // 执行支付单及查询支付单
            super.capitalOrderMock(capitalOrders);
        } finally {
            // 校验数据
            super.checkDB(iCase);
            super.clearDB(iCase);
        }
    }
}
