/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */

package com.abssqr.plat.test.unittest.job.keeper;

import com.abssqr.plat.biz.shared.scheduler.job.keeper.node.BalanceCheckKeeper;
import com.abssqr.plat.biz.shared.scheduler.job.sync.ast.ZLOriginalAstSyncJob;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 *
 * @author xiachenxiang
 * @version com.abssqr.plat.test.unittest.job: BalanceCheckKeeperTest.java, v 0.1 2019-10-08 11:41 AM xiachenxiang Exp $ 
 */
public class BalanceCheckKeeperTest extends BaseAutoTests {

    @Autowired
    private BalanceCheckKeeper balanceCheckKeeper;
    @Autowired
    private ZLOriginalAstSyncJob zlOriginalAstSyncJob;

    @XTest(relatePath = "unittest/job/balanceCheckKeeper")
    @Test(dataProvider = "YamlDataProvider", description = "余额校验")
    public void jobTest(ICase iCase, String strDate) throws ParseException {
        try {
            // 更新会计日期
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            SimpleDateFormat sdf2 = new SimpleDateFormat("yyyy-MM-dd");
            Date date = sdf.parse(strDate);
            updateDate(sdf2.parse(strDate), OrgCodeEnum.ABS.getCode());
            mockBalanceCheckKeeper(date);
            validJobCtr(zlOriginalAstSyncJob.getJobName());
            balanceCheckKeeper.execute(date);
    
            invalidJobCtr(zlOriginalAstSyncJob.getJobName());
        }catch (Exception e){
            e.printStackTrace();
        }finally {
            // 校验数据
            super.checkDB(iCase);
            super.clearDB(iCase);
        }
    }
}