package com.abssqr.plat.test.unittest.job.keeper;

import com.abssqr.plat.biz.shared.scheduler.job.keeper.node.BalanceReportKeeper;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

public class BalanceReportKeeperTest extends BaseAutoTests {
    @Autowired
    private BalanceReportKeeper balanceReportKeeper;
    @XTest(relatePath = "unittest/job/BalanceReportKeeper")
    @Test(dataProvider = "YamlDataProvider", description = "每日十点余额通知")
    public void jobTest(ICase iCase, String strDate) {
        try {
            // 更新会计日期
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date date = sdf.parse(strDate);
            mockBalanceReportKeeper(date);
            balanceReportKeeper.execute(date);
        } catch (ParseException e) {
            throw new RuntimeException(e.getMessage());
        } finally {
            // 校验数据
            super.checkDB(iCase);
            super.clearDB(iCase);
        }
    }
}
