/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */

package com.abssqr.plat.test.unittest.job.keeper;

import com.abssqr.plat.biz.shared.scheduler.job.keeper.node.CapitalOrderKeeper;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanCapitalOrderJob;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author xiachenxiang
 * @version com.abssqr.plat.test.unittest.job: CapitalOrderKeeperTest.java, v 0.1 2019-09-29 11:45 AM xiachenxiang Exp $
 */
public class CapitalOrderKeeperTest extends BaseAutoTests {

    @Autowired
    private CapitalOrderKeeper capitalOrderKeeper;
    @Autowired
    private PlanCapitalOrderJob planCapitalOrderJob;

    @XTest(relatePath = "unittest/job/capitalOrderKeeper")
    @Test(dataProvider = "YamlDataProvider", description = "资产同步监控任务")
    public void jobTest(ICase iCase, String strDate) throws ParseException {
        // 更新会计日期
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date date = sdf.parse(strDate);
        updateDate(date, OrgCodeEnum.ABS.getCode());
        try {
            validJobCtr(planCapitalOrderJob.getJobName());
            capitalOrderKeeper.execute(date);
    
            invalidJobCtr(planCapitalOrderJob.getJobName());
        } finally {
            // 校验数据
            super.checkDB(iCase);
            super.clearDB(iCase);
        }

    }
}
