/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */

package com.abssqr.plat.test.unittest.job.keeper;

import com.abssqr.plat.biz.shared.dispatcher.planAstStat.PlanAstStatTaskStarter;
import com.abssqr.plat.biz.shared.scheduler.job.keeper.node.PlanAstStatJobKeeper;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/**
 * @author xiachenxiang
 * @version com.abssqr.plat.test.unittest.job: PlanAstStatJobKeeper.java, v 0.1 2019-09-29 3:01 PM xiachenxiang Exp $
 */
public class PlanAstStatJobKeeperTest extends BaseAutoTests {

    @Autowired
    private PlanAstStatJobKeeper planAstStatJobKeeper;

    @Autowired
    private PlanAstStatTaskStarter planAstStatTaskStarter;

    @XTest(relatePath = "unittest/job/planAstStatJobKeeper")
    @Test(dataProvider = "YamlDataProvider", description = "放款计划统计任务监控")
    public void jobTest(ICase iCase, String strDate) throws ParseException {
        try {
            // 更新会计日期
            SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
            Date date = sdf.parse(strDate);
            updateDate(date, OrgCodeEnum.ABS.getCode());
            validJobCtr(planAstStatTaskStarter.getName());
            planAstStatJobKeeper.execute(date);
    
            invalidJobCtr(planAstStatTaskStarter.getName());
        } finally {
            // 校验数据
            super.checkDB(iCase);
            super.clearDB(iCase);
        }
    }
}
