/**
 * abssqr.com Inc. 
 * Copyright (c) 2017-2019 All Rights Reserved. 
 */
package com.abssqr.plat.test.unittest.job;

import com.abssqr.plat.biz.shared.handler.PlanAstClearingOrderHandler;
import com.abssqr.plat.common.facade.model.plan.PlanCapitalOrder;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.common.model.repo.plan.PlanCapitalOrderRepo;
import com.abssqr.plat.common.model.repo.plan.PlanRepo;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.util.List;

/**
 * 资金交易单查询结果成功后续处理
 * @author hanfei
 * @version $Id: planCapitalOrderResJobTest.java, v 0.1 2019-09-06 11:26 AM hanfei Exp $
 */
public class planCapitalOrderResJobTest extends BaseAutoTests {
    
    @Autowired
    private PlanCapitalOrderRepo        planCapitalOrderRepo;
    @Autowired
    private PlanAstClearingOrderHandler planAstClearingOrderHandler;
    @Autowired
    private PlanRepo                    planRepo;
    
    @XTest(relatePath = "unittest/job/capitalOrderRes")
    @Test(dataProvider = "YamlDataProvider", description = "交易单查询结果")
    public void capitalOrder(ICase iCase, String planNo, String acctDate) {
        try {
            super.updateDate(acctDate, OrgCodeEnum.ABS.getCode());
            /**
             * 先处理结算
             */
            planAstClearingOrderHandler.handle(planRepo.getPlanByNo(planNo));

            // 资金订单状态由wait-->succ， 记得修改next_exec_time <= sysdate
            List<PlanCapitalOrder> capitalOrders = planCapitalOrderRepo.getInitListByPlanNo(planNo);
            // 执行支付单及查询支付单
            super.capitalOrderMock(capitalOrders);
        } finally {
            // 校验数据
            super.checkDB(iCase);
            super.clearDB(iCase);
        }
    }
}
