package com.abssqr.plat.test.unittest.report;

import java.util.Date;
import java.util.List;
import java.util.Map;

import cn.hutool.core.date.DateUtil;
import com.abssqr.plat.biz.shared.dispatcher.TaskGroupService;
import com.abssqr.plat.biz.shared.dispatcher.match.PlanAstMatchDispatcherExecutor;
import com.abssqr.plat.biz.shared.dispatcher.match.PlanAstMatchDispatcherLoader;
import com.abssqr.plat.biz.shared.dispatcher.match.PlanAstMatchDispatcherStarter;
import com.abssqr.plat.biz.shared.dispatcher.transfer.AstTrTaskExecutor;
import com.abssqr.plat.biz.shared.dispatcher.transfer.AstTrTaskLoader;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherExecutor;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherLoader;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherSplitor;
import com.abssqr.plat.biz.shared.dispatcher.wkAstSync.mfs.WkMfsAstSyncDispatcherStarter;
import com.abssqr.plat.biz.shared.dispatcher.wkPlanReport.PlanReportTaskExecutor;
import com.abssqr.plat.biz.shared.dispatcher.wkPlanReport.PlanReportTaskLoader;
import com.abssqr.plat.biz.shared.dispatcher.wkPlanReport.PlanReportTaskStarter;
import com.abssqr.plat.biz.shared.handler.PlanAstClearingOrderHandler;
import com.abssqr.plat.biz.shared.handler.PlanAstClearingStatHandler;
import com.abssqr.plat.biz.shared.handler.PlanAstStatTaskHandler;
import com.abssqr.plat.biz.shared.handler.PlanFundHandler;
import com.abssqr.plat.biz.shared.handler.WkPlanReportHandler;
import com.abssqr.plat.biz.shared.scheduler.job.ast.ZLFinSerFeeJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanCapitalOrderJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanDailyJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanPackJob;
import com.abssqr.plat.common.dal.mysql.auto.dao.BizDataChangeDAO;
import com.abssqr.plat.common.dal.mysql.auto.dataobject.BizDataChangeDO;
import com.abssqr.plat.common.facade.enums.CommonTaskTypeEnum;
import com.abssqr.plat.common.facade.enums.OrgAstStatStatusEnum;
import com.abssqr.plat.common.facade.enums.PlanStatusEnum;
import com.abssqr.plat.common.facade.model.plan.PlanBase;
import com.abssqr.plat.common.facade.model.plan.PlanCapitalOrder;
import com.abssqr.plat.common.facade.param.analyse.AnalyseBaseParam;
import com.abssqr.plat.common.facade.param.analyse.AnalyseTrendChartParam;
import com.abssqr.plat.common.facade.param.analyse.CalcFundParam;
import com.abssqr.plat.common.facade.param.plan.PlanOprParam;
import com.abssqr.plat.common.facade.param.plan.PlanPageQryParam;
import com.abssqr.plat.common.facade.param.plan.alloc.PlanAllocQryParam;
import com.abssqr.plat.common.facade.result.BasePage;
import com.abssqr.plat.common.facade.result.analyse.AnalyseChartResultVO;
import com.abssqr.plat.common.facade.result.analyse.AnalyseDayAmtInfoVO;
import com.abssqr.plat.common.facade.result.analyse.AnalyseDayAstInfoVO;
import com.abssqr.plat.common.facade.result.analyse.CalcFundDefaultParam;
import com.abssqr.plat.common.facade.result.analyse.CalcFundResultVO;
import com.abssqr.plat.common.facade.result.analyse.FormationAstItemVO;
import com.abssqr.plat.common.facade.result.analyse.PlanAnalyseVO;
import com.abssqr.plat.common.facade.service.analyse.AnalyseFundSpvService;
import com.abssqr.plat.common.facade.service.analyse.AnalyseInfoChartService;
import com.abssqr.plat.common.facade.service.plan.PlanAllocService;
import com.abssqr.plat.common.facade.service.plan.PlanService;
import com.abssqr.plat.common.model.domain.plan.PlanAstStatTask;
import com.abssqr.plat.common.model.domain.task.CommonTask;
import com.abssqr.plat.common.model.domain.task.TrTask;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.common.model.repo.ast.PlanAstStatTaskRepo;
import com.abssqr.plat.common.model.repo.plan.PlanCapitalOrderRepo;
import com.abssqr.plat.common.model.repo.plan.PlanRepo;
import com.abssqr.plat.common.model.repo.report.PlanReportRepo;
import com.abssqr.plat.common.model.wk.domain.sync.WkMfsSyncCtr;
import com.abssqr.plat.common.model.wk.repo.WkMfsSyncCtrRepo;
import com.abssqr.plat.common.util.base.Day;
import com.abssqr.plat.core.service.accounting.OrgAcctDayComponent;
import com.abssqr.plat.core.service.change.ChangeManager;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import com.general.system.bpm.domain.result.ProcessAfterResult;
import com.general.system.bpm.enums.ApproveStatusEnum;
import com.general.system.common.util.DateTimeUtil;
import com.general.system.common.util.LogUtil;
import com.general.system.core.common.constant.factory.ConstantFactory;
import com.general.system.tool.util.ToolUtil;
import com.google.common.collect.Lists;
import org.junit.Assert;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

/**
 * 报表及项目分析页面统计
 */

//@ActiveProfiles("dev")
public class PlanReportChartTest extends BaseAutoTests {
    @Autowired
    private PlanService                     planService;
    @Autowired
    private PlanAstStatTaskHandler          planAstStatTaskHandler;
    @Autowired
    private PlanDailyJob                    planDailyJob;
    @Autowired
    private ChangeManager                   changeManager;
    @Autowired
    private AstTrTaskLoader                 astTrTaskLoader;
    @Autowired
    private PlanFundHandler                 planFundHandler;
    @Autowired
    private PlanRepo                        planRepo;
    @Autowired
    private PlanAllocService               planAllocService;
    @Autowired
    private AstTrTaskExecutor              astTrTaskExecutor;
    @Autowired
    private PlanAstStatTaskRepo            planAstStatTask;
    @Autowired
    private PlanAstClearingStatHandler     planAstStatHandler;
    @Autowired
    private WkMfsAstSyncDispatcherLoader   wkMfsAstSyncDispatcherLoader;
    @Autowired
    private WkMfsAstSyncDispatcherSplitor  wkMfsAstSyncDispatcherSplitor;
    @Autowired
    private WkMfsAstSyncDispatcherExecutor wkMfsAstSyncDispatcherExecutor;
    @Autowired
    private WkMfsAstSyncDispatcherStarter  wkMfsAstSyncDispatcherStarter;
    @Autowired
    private WkMfsSyncCtrRepo               wkMfsSyncCtrRepo;
    @Autowired
    private BizDataChangeDAO               bizDataChangeDAO;
    @Autowired
    private ZLFinSerFeeJob                 zlFinSerFeeJob;
    @Autowired
    private PlanAstClearingOrderHandler    planAstClearingOrderHandler;
    @Autowired
    private PlanCapitalOrderRepo           planCapitalOrderRepo;
    @Autowired
    private PlanPackJob                    planPackJob;
    @Autowired
    private PlanReportTaskStarter           planReportTaskStarter;
    @Autowired
    private PlanReportTaskLoader            planReportTaskLoader;
    @Autowired
    private PlanReportTaskExecutor          planReportTaskExecutor;
    @Autowired
    private PlanAstMatchDispatcherLoader   planAstMatchLoader;
    @Autowired
    private PlanAstMatchDispatcherExecutor planAstMatchExecutor;
    @Autowired
    private PlanAstMatchDispatcherStarter  planAstMatchDispatcherStarter;
    @Autowired
    private PlanReportRepo                 planReportRepo;
    @Autowired
    private PlanCapitalOrderJob            planCapitalOrderJob;
    @Autowired
    private WkPlanReportHandler            wkPlanReportHandler;
    @Autowired
    private OrgAcctDayComponent            orgAcctDayComponent;
    
    @XTest(relatePath = "unittest/planReport/chart")
    @Test(dataProvider = "YamlDataProvider", description = "创建并生效计划", priority = 1)
    public void createPlanTestChart(ICase iCase, String acctDate, PlanOprParam planParam) {
        
        ConstantFactory.me().securityLogin("administrator");
        
        // 更新会计日期
        try {
            Date strDate = DateUtil.parseDate(acctDate);
            super.updateDate(strDate, OrgCodeEnum.ABS.getCode());
    
            // 计划管理-->提交审批
            LogUtil.info(logger, " ---- 1 计划初始化");
            planService.edit(planParam);
            
            BizDataChangeDO bizData = bizDataChangeDAO.getByBizNoAndStatus(planParam.getPlanNo(), "PENDING");
            if (bizData != null) {
                // 审批-->创建水位与科目
                ProcessAfterResult result = new ProcessAfterResult();
                result.setBusinessKey(bizData.getChangeNo());
                result.setStatusEnum(ApproveStatusEnum.PASSED);
                changeManager.handle(result);
            }
            
            // 计划日切更新状态
            super.updateDate(DateTimeUtil.addDays(strDate, 1), OrgCodeEnum.ABS.getCode());
    
            Day trfDate = orgAcctDayComponent.getTrfAcctDay();
            
            PlanBase planEntity = planRepo.getPlanByNo(planParam.getPlanNo());
            //执行计划每日任务
            planDailyJob.lockEntityAndExecute(trfDate.getStandardDate(), planEntity);
            
            // 执行余额查询
            LogUtil.info(logger, " ---- 2 执行余额查询");
            planFundHandler.executeQueryBalance(planEntity, new Day(strDate));
            
            // 生成默认分配计划
            LogUtil.info(logger, " ---- 3 生成默认分配计划");
            PlanAllocQryParam allocParm = new PlanAllocQryParam();
            allocParm.setPlanNo(planParam.getPlanNo());
            planAllocService.getPlanAlloc(allocParm);
            
        } finally {
            // 校验数据
            checkDB(iCase);
        }
    }
    
    /**
     * 进行同步数据处理  testOnly 按顺序执行用例文件
     * @param iCase
     * @param acctDate
     * @param planNo
     * @param spvNo
     * @param orgCode
     */
    @XTest(relatePath = "dal/wkdata",
           testOnly = { "initWKData_chart_20190703", "initWKData_chart_20190704", "initWKData_chart_20190705" })
    @Test(dataProvider = "YamlDataProvider", description = "同步五矿数据-初始化", priority = 2)
    public void dailyJobChart(ICase iCase, String acctDate, String planNo, String spvNo, String orgCode) {
        
        try {
            // 创建分区
            autoPartition(OrgCodeEnum.getByCode(orgCode).getCode());
            // 更新会计日期
            Day strDate = new Day(acctDate);
            super.updateDate(strDate.getTomorrow().getStandardDate(), OrgCodeEnum.ABS.getCode());
            // 对应机构日
            super.updateDate(strDate.getStandardDate(), orgCode);
//            // 会计日切换
//            orgAcctDayComponent.acctDaySwitch();
            // 执行业务
            PlanBase plan = planRepo.getPlanByNo(planNo);
            PlanBase spv = planRepo.getPlanByNo(spvNo);
            // 整体流程
            this.execute(plan, spv, orgCode);
        } finally {
            checkDB(iCase);
            //            super.clearDB(iCase);
        }
    }
    
    /**
     * 机构编码
     */
    private void execute(PlanBase plan, PlanBase spv, String orgCode) {
        String planNo = plan.getPlanNo();
        String spvNo = spv.getPlanNo();
        Day trfDate = orgAcctDayComponent.getTrfAcctDay();
        
        LogUtil.info(logger, " ---- 2 计划每日任务");
        planDailyJob.lockEntityAndExecute(trfDate.getStandardDate(), plan);
        planDailyJob.lockEntityAndExecute(trfDate.getStandardDate(), spv);
        
        LogUtil.info(logger, " ---- 3 五矿数据模型转换");
        List<WkMfsSyncCtr> syncNodes = wkMfsAstSyncDispatcherLoader.loadToDoNodes(
                new TaskGroupService() {
                    @Override
                    public List getTasks() {
                        return  Lists.newArrayList(1L, 9999999L);
                    }
                
                    @Override
                    public void finish() {
                    
                    }
                }
                , new TaskGroupService() {
                    @Override
                    public List getTasks() {
                        return Lists.newArrayList();
                    }
                
                    @Override
                    public void finish() {
                    
                    }
                }
                , 20);
        for (WkMfsSyncCtr syncNode : syncNodes) {
            if (ToolUtil.equals(syncNode.getOrgNo(), orgCode)){
                wkMfsAstSyncDispatcherExecutor.doExecute(syncNode);
            }
        }
//        wk1009AstSyncDispatcherSplitor.setOrgCode(orgCode);
        //所有同步数据处理完成后，更新任务为成功
        LogUtil.info(logger, " ---- 更新任务");
        wkMfsAstSyncDispatcherSplitor.split();
        
        // 筛选资产包创建
        LogUtil.info(logger, " ---- 4 筛选资产包创建");
        planPackJob.doExecute();
        
        LogUtil.info(logger, " ---- 5 资产筛选");
        List<CommonTask> commonTask = planAstMatchLoader.loadToDoNodes(10);
        for (CommonTask task : commonTask) {
            if (task.getTaskType().equals(CommonTaskTypeEnum.PACK_MATCH)) {
                planAstMatchExecutor.doExecute(task);
            }
        }
        
        LogUtil.info(logger, " ---- 6 资产转让");
        List<TrTask> trTasks = astTrTaskLoader.loadToDoNodes(10);
        for (TrTask trTask : trTasks) {
            astTrTaskExecutor.doExecute(trTask);
        }
        
        LogUtil.info(logger, " ---- 10 金融服务费定时任务统计");
        zlFinSerFeeJob.setZlOrgCode(orgCode);
        zlFinSerFeeJob.doExecute();
        
        LogUtil.info(logger, " ---- 7 清算汇总");
        planAstStatTaskHandler.handle(planNo, trfDate);
        planAstStatTaskHandler.handle(spvNo, trfDate);
        
        String execTms = "999912312359";
        PlanAstStatTask astStatTask1 = planAstStatTask.getPlanNo(planNo);
        if (astStatTask1 != null) {
            astStatTask1.setStatus(OrgAstStatStatusEnum.PROCESS);
            astStatTask1.setMinId(null);
            planAstStatTask.updateTask(astStatTask1);
            planAstStatHandler.execute(astStatTask1, execTms);
        }
        PlanAstStatTask astStatTask2 = planAstStatTask.getPlanNo(spvNo);
        if (astStatTask2 != null) {
            astStatTask2.setStatus(OrgAstStatStatusEnum.PROCESS);
            planAstStatTask.updateTask(astStatTask2);
            planAstStatHandler.execute(astStatTask2, execTms);
            astStatTask2.setAccountDate(trfDate.getStandardDate());
            astStatTask2.setMinId(null);
            astStatTask2.setStatus(OrgAstStatStatusEnum.PROCESS);
            planAstStatTask.updateTask(astStatTask2);
            planAstStatHandler.execute(astStatTask2, execTms);
        }
        
        // 结算任务处理
        LogUtil.info(logger, " ---- 8 结算处理");
        planAstClearingOrderHandler.handle(plan);
        planAstClearingOrderHandler.handle(spv);
        
        // wk交易调用
        // 资金订单状态由wait-->succ， 记得修改next_exec_time <= sysdate
        LogUtil.info(logger, " ---- 9 支付处理");
        super.validJobCtr(planCapitalOrderJob.getJobName());
        List<PlanCapitalOrder> capitalOrders = planCapitalOrderRepo.getInitListByPlanNo(planNo);
        capitalOrders.addAll(planCapitalOrderRepo.getInitListByPlanNo(spvNo));
        super.capitalOrderMock(capitalOrders);
        
        // 放款池可能会有回转放的结算单需要执行
        planAstClearingOrderHandler.handle(spv);
        List<PlanCapitalOrder> spvReturn = planCapitalOrderRepo.getInitListByPlanNo(spv.getPlanNo());
        super.capitalOrderMock(spvReturn);
        super.invalidJobCtr(planCapitalOrderJob.getJobName());
        
        // 放款池的Item_default 初始化
        planReportRepo.defaultRPT001Init(spv.getPlanNo(), spv.getBeginDate());
        
        
        LogUtil.info(logger, " ---- 11 计划报表");
        List<CommonTask> tasks = planReportTaskLoader.loadToDoNodes(20);
        while (tasks.size() > 0){
            for(CommonTask task: tasks){
                if(ToolUtil.equals(task.getContext(), planNo))
                    planReportTaskExecutor.doExecute(task);
            }
        
            for(CommonTask task: tasks){
                if(ToolUtil.equals(task.getContext(), spvNo))
                    planReportTaskExecutor.doExecute(task);
            }
        
            tasks = planReportTaskLoader.loadToDoNodes(20);
        }
    }
    
    @Autowired
    private AnalyseInfoChartService analyseInfoChartService;
    
    @XTest(relatePath = "unittest/planReport/overview")
    @Test(dataProvider = "YamlDataProvider", description = "资金分析", priority = 3)
    public void overviewAmtTest(ICase iCase, AnalyseBaseParam param) {
        try {
            AnalyseDayAmtInfoVO result = analyseInfoChartService.getDayAmtInfo(param);
            Assert.assertNotNull(result);
        } finally {
        }
    }
    
    @XTest(relatePath = "unittest/planReport/overview")
    @Test(dataProvider = "YamlDataProvider", description = "资产分析", priority = 3)
    public void overviewAstTest(ICase iCase, AnalyseBaseParam param) {
        
        try {
            AnalyseDayAstInfoVO result = analyseInfoChartService.getDayAstInfo(param);
            Assert.assertNotNull(result);
        } finally {
        }
    }
    
    @XTest(relatePath = "unittest/planReport/overview")
    @Test(dataProvider = "YamlDataProvider", description = "资产分期结构", priority = 3)
    public void formationAstTest(ICase iCase, AnalyseBaseParam param) {
        try {
            Map<String, List<FormationAstItemVO>> result = analyseInfoChartService.getFormationAst(param);
            Assert.assertNotNull(result);
        } finally {
            checkDB(iCase);
        }
    }
    
    @XTest(relatePath = "unittest/planReport/analyse")
    @Test(dataProvider = "YamlDataProvider", description = "统计图数据", priority = 3)
    public void chartNodeTest(ICase iCase, AnalyseTrendChartParam param) {
        try {
            AnalyseChartResultVO resultVO = analyseInfoChartService.trendChartService(param);
            Assert.assertNotNull(resultVO);
        } finally {
        }
    }
    
    @Autowired
    private AnalyseFundSpvService analyseFundSpvService;
    
    @XTest(relatePath = "unittest/planReport/overview")
    @Test(dataProvider = "YamlDataProvider", description = "查询计划概要信息", priority = 3)
    public void testAnalyseSpvPlan(ICase iCase, AnalyseBaseParam param) {
        try {
            PlanAnalyseVO result = analyseFundSpvService.getAnalyseSpvPlan(param);
            Assert.assertNotNull(result);
        } finally {
        }
    }
    
    @XTest(relatePath = "unittest/planReport/overview")
    @Test(dataProvider = "YamlDataProvider", description = "获取短期资金需求计算器默认显示数据", priority = 3)
    public void testFundCalcView(ICase iCase, AnalyseBaseParam param) {
        try {
            CalcFundDefaultParam result = analyseFundSpvService.fundCalcView(param);
            Assert.assertNotNull(result);
        } finally {
        }
        
    }
    
    @XTest(relatePath = "unittest/planReport/calc")
    @Test(dataProvider = "YamlDataProvider", description = "短期资金需求计算器", priority = 4)
    public void testFundCalcView(ICase iCase, CalcFundParam param) {
        try {
            CalcFundResultVO result = analyseFundSpvService.fundCalc(param);
            Assert.assertNotNull(result);
        } finally {
        }
        
    }
    
    @XTest(relatePath = "unittest/planReport/page")
    @Test(dataProvider = "YamlDataProvider", description = "查询项目计划分析列表", priority = 4)
    public void testQueryAnalyseSpvPlan(ICase iCase, PlanPageQryParam param) {
        try {
            ConstantFactory.me().securityLogin("administrator");
            
            BasePage result = analyseFundSpvService.queryAnalyseSpvPlan(param);
            Assert.assertNotNull(result);
        } finally {
        }
        
    }
    
    @XTest(relatePath = "unittest/planReport/month" )
    @Test(dataProvider = "YamlDataProvider", description = "测试项目管理报表", priority = 5)
    public void MonthReport(ICase iCase, String acctDate, String spvPlanNo, String planNo) {
        try {
            Date strDate = DateUtil.parse(acctDate);
            super.updateDate(strDate, OrgCodeEnum.ABS.getCode());
            
            List<PlanBase> onGoingPlans = planRepo.getPlansByStatus(null, PlanStatusEnum.ONGOING);
            for (PlanBase planBase : onGoingPlans) {
                if (ToolUtil.equals(planBase.getPlanNo(), spvPlanNo)
                    || ToolUtil.equals(planBase.getPlanNo(), planNo)) {
                    wkPlanReportHandler.checkAndBuildMonthPlanReport(strDate, planBase);
                }
            }
        } finally {
            checkDB(iCase);
        }
    }
}
