/**
 * abssqr.com Inc. 
 * Copyright (c) 2017-2019 All Rights Reserved. 
 */
package com.abssqr.plat.test.unittest.report;

import cn.hutool.core.date.DateUtil;
import com.abssqr.plat.biz.shared.handler.WkPlanReportHandler;
import com.abssqr.plat.common.facade.model.plan.PlanBase;
import com.abssqr.plat.common.model.repo.report.PlanReportRepo;
import com.abssqr.plat.core.service.plan.PlanManager;
import com.abssqr.plat.test.BaseAutoTests;
import com.abssqr.test.annotation.XTest;
import com.abssqr.test.icase.ICase;
import org.springframework.beans.factory.annotation.Autowired;
import org.testng.annotations.Test;

import java.util.Date;

/**
 * 报表默认数据测试
 * @author hanfei
 * @version $Id: PlanReportDefaultTest.java, v 0.1 2019-12-25 2:25 PM hanfei Exp $
 */
public class PlanReportDefaultTest extends BaseAutoTests {
    
    @Autowired
    private WkPlanReportHandler wkPlanReportHandler;
    @Autowired
    private PlanReportRepo      planReportRepo;
    @Autowired
    private PlanManager         planManager;
    
    @XTest(relatePath = "unittest/planReport/default")
    @Test(dataProvider = "YamlDataProvider", description = "生成默认item", priority = 1)
    public void defaultRPT001InitTest(ICase iCase, String acctDate, String planNo) {
        try {
            Date accountDate = DateUtil.parse(acctDate);
            PlanBase planBase = planManager.getPlanFullByNo(planNo);
            
            planReportRepo.defaultRPT001Init(planBase.getPlanNo(), accountDate);
            
        } finally {
            super.checkDB(iCase);
            //super.clearDB(iCase);
        }
    }
    
}
