/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.test.unittest.wk;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;
import java.io.PrintWriter;
import java.io.UnsupportedEncodingException;
import java.net.URL;
import java.net.URLConnection;
import java.net.URLDecoder;
import java.net.URLEncoder;

import org.testng.annotations.Test;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.test.unittest.wk: WkPayCallBackTest.java, v 0.1 2019-06-21 18:25 bangis.wangdf Exp $
 */
public class WkPayCallBackTest {
    @Test
    public void testCall() {
        String xxx = null;
        try {
            xxx = callXW("z水电费水电费是", "http://localhost:8007/wkplat/callback/wkpay/trade");
        } catch (Exception e) {
            e.printStackTrace();
        }
        System.out.println(xxx);
    }

    /**
     * 回调小微
     *
     * @param msg 回调参数
     * @param url 回调小微地址
     * @return
     * @throws Exception
     */
    public static String callXW(String msg, String url) throws Exception {
        PrintWriter out = null;
        BufferedReader in = null;
        String result = "";
        try {
            URL realUrl = new URL(url);
            // 打开和URL之间的连接
            URLConnection conn = realUrl.openConnection();
            // 设置通用的请求属性
            conn.setRequestProperty("accept", "*/*");
            conn.setRequestProperty("connection", "Keep-Alive");
            conn.setRequestProperty("user-agent", "Mozilla/4.0 (compatible; MSIE 6.0; Windows NT 5.1;SV1)");
            //conn.setRequestProperty("Content-Type", "application/x-www-form-urlencoded;charset=utf-8");
            // 发送POST请求必须设置如下两行
            conn.setDoOutput(true);
            conn.setDoInput(true);
            //
            conn.setConnectTimeout(1000);
            // 获取URLConnection对象对应的输出流
            out = new PrintWriter(new OutputStreamWriter(conn.getOutputStream(), "GBK"));
            // 发送请求参数
            String messge = "msg=" + URLEncoder.encode(msg, "GBK");
            out.print(messge);
            // flush输出流的缓冲
            out.flush();
            // 定义BufferedReader输入流来读取URL的响应
            in = new BufferedReader(new InputStreamReader(conn.getInputStream()));
            String line;
            while ((line = in.readLine()) != null) {
                result += line;
            }
        }
        // 使用finally块来关闭输出流、输入流
        finally {
            try {
                if (out != null) {
                    out.close();
                }
                if (in != null) {
                    in.close();
                }
            } catch (IOException ex) {
                ex.printStackTrace();
            }
        }
        return result;
    }

    public static void main(String[] args) throws UnsupportedEncodingException {
        String testGBK = new String("z水电费水电费是".getBytes());
        String encodeGBK = URLEncoder.encode(testGBK, "GBK");
        String decodeUtf8 = URLDecoder.decode(encodeGBK, "UTF-8");

        String d0 = URLEncoder.encode(decodeUtf8, "GBK");

        String d1 = URLEncoder.encode(decodeUtf8, "UTF-8");
        String d2 = URLDecoder.decode(d1, "UTF-8");
        String testUtf8 = new String(decodeUtf8.getBytes("UTF-8"), "GBK");
        String t1 = new String(testUtf8.getBytes("GBK"), "UTF-8");
        return;
    }
}
