/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2018 All Rights Reserved.
 */

package com.abssqr.plat.web.controller.job;

//import com.abssqr.plat.biz.shared.scheduler.job.plan.LenderOrgAstClearingOrderJob;
//import com.abssqr.plat.biz.shared.scheduler.job.plan.LenderOrgAstStatJob;

import cn.hutool.core.date.DateUtil;
import com.abssqr.plat.biz.shared.handler.WkPlanReportHandler;
import com.abssqr.plat.biz.shared.scheduler.job.ast.ZLFinSerFeeJob;
import com.abssqr.plat.biz.shared.scheduler.job.capitalAssertMatch.CapitalAssertMatchJob;
import com.abssqr.plat.biz.shared.scheduler.job.keeper.node.WkDataCheckKeeper;
import com.abssqr.plat.biz.shared.scheduler.job.plan.LenderOrgCapitalJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanAstClearingOrderJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanAstStatJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanCapitalOrderJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanCapitalOrderResJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanDailyJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanFundJob;
import com.abssqr.plat.biz.shared.scheduler.job.plan.PlanPackJob;
import com.abssqr.plat.biz.shared.scheduler.job.sync.ast.ZLOriginalAstSyncJob;
import com.abssqr.plat.common.facade.enums.PlanTypeEnum;
import com.abssqr.plat.common.facade.enums.ReportTypeEnum;
import com.abssqr.plat.common.facade.model.account.Account;
import com.abssqr.plat.common.facade.model.plan.PlanBase;
import com.abssqr.plat.common.facade.model.report.DailyReportDateField;
import com.abssqr.plat.common.facade.model.report.PlanReport;
import com.abssqr.plat.common.facade.service.AccountService;
import com.abssqr.plat.common.integration.wk.enums.WkChannelNoEnum;
import com.abssqr.plat.common.model.domain.task.ctr.AstSyncTaskCtr;
import com.abssqr.plat.common.model.enums.OrgCodeEnum;
import com.abssqr.plat.common.model.repo.plan.PlanRepo;
import com.abssqr.plat.common.model.repo.report.PlanReportRepo;
import com.abssqr.plat.common.model.repo.task.AstSyncTaskCtrRepo;
import com.abssqr.plat.common.util.base.Day;
import com.abssqr.plat.common.util.utils.DayUtil;
import com.abssqr.plat.core.service.accounting.OrgAcctDayComponent;
import com.abssqr.plat.core.service.plan.PlanManager;
import com.abssqr.plat.core.service.wk.pay.WkPayManager;
import com.general.enhanced.controller.annotation.RestJsonController;
import com.general.system.common.model.BaseResult;
import com.general.system.common.model.Money;
import com.general.system.common.util.VarChecker;
import com.general.system.tool.util.ToolUtil;
import com.google.common.collect.Lists;
import org.apache.commons.lang3.StringUtils;
import org.apache.commons.lang3.tuple.MutablePair;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestMethod;
import org.springframework.web.bind.annotation.RequestParam;

import java.util.List;

/**
 * job 手工出发
 *
 * @author yaphet
 * @version com.abssqr.admin.web.controller.product: ProductController.java, v 0.1 2018-03-02 下午3:32 yaphet Exp $
 */
@RestJsonController
public class JobController {

    @Autowired
    private     AstSyncTaskCtrRepo     astSyncTaskCtrRepo;
    @Autowired
    private     ZLOriginalAstSyncJob   zlOriginalAstSyncJob;
    @Autowired
    private     WkPlanReportHandler    wkPlanReportHandler;
    @Autowired
    private PlanManager             planManager;
    @Autowired
    private PlanRepo                planRepo;
    @Autowired
    private PlanAstClearingOrderJob planAstClearingOrderJob;
    @Autowired
    private LenderOrgCapitalJob     lenderOrgCapitalJob;
    @Autowired
    private PlanAstStatJob         planAstStatJob;
    @Autowired
    private     PlanCapitalOrderJob    planCapitalOrderJob;
    @Autowired
    private     PlanCapitalOrderResJob planCapitalOrderResJob;
    @Autowired
    private     PlanDailyJob           planDailyJob;
    @Autowired
    private     PlanFundJob            planFundJob;
    @Autowired
    private     PlanPackJob            planPackJob;
    @Autowired
    private     WkPayManager           wkPayManager;
    @Autowired
    private     ZLFinSerFeeJob         zlFinSerFeeJob;
    @Autowired
    private     PlanReportRepo         planReportRepo;
    @Autowired
    private     AccountService         accountService;
    @Autowired
    private     WkDataCheckKeeper      wkDataCheckKeeper;
    @Autowired
    private     CapitalAssertMatchJob  capitalAssertMatchJob;
    @Autowired
    private     OrgAcctDayComponent    orgAcctDayComponent;
    /**
     * checkData
     *
     * @return
     */
    @RequestMapping(path = "/checkData.json", method = RequestMethod.GET)
    public BaseResult<Boolean> checkData(String orgCode) {
        OrgCodeEnum orgCodeEnum = OrgCodeEnum.getByCode(orgCode);
        VarChecker.checkNotNull(orgCodeEnum, "机构编码不正确");
        Day curDate = orgAcctDayComponent.getTrfAcctDay();
        StringBuilder sb= new StringBuilder();
        
        Day orgDate = orgAcctDayComponent.getAstAcctDay(orgCodeEnum);
        wkDataCheckKeeper.checkData(curDate, orgCode, orgDate, sb);
        BaseResult result = BaseResult.success(true);
        result.setDataObject(sb.toString());
        return result;
    }

    /**
     * 计划资产包生成任务
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/planPackJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> planPackJob() {
        planPackJob.doExecute();
        return BaseResult.success(null);
    }

    /**
     * 每日处理
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/planDailyJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> planDailyJob() {
        planDailyJob.doExecute();
        return BaseResult.success(null);
    }

    /**
     * 资金到账情况查询
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/planFundJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> planFundJob() {
        planFundJob.doExecute();
        return BaseResult.success(null);
    }

    /**
     * 招联资产数据同步
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/zlOriginalAstSyncJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> zlOriginalAstSyncJob(String all, String orgCode) {
        AstSyncTaskCtr astSyncTaskCtr = astSyncTaskCtrRepo.getAstSyncTaskCtr(orgCode);
        if (StringUtils.equals(all, "Y")) {
            astSyncTaskCtr.getExtData().setSyncAll(true);
        } else {
            astSyncTaskCtr.getExtData().setSyncAll(false);
        }
        zlOriginalAstSyncJob.doExecute(astSyncTaskCtr);
        return BaseResult.success(null);
    }

    /**
     * 手动触发交易支付单
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/planCapitalOrderJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> planCapitalOrderJob() {
        planCapitalOrderJob.doExecute();
        return BaseResult.success(null);
    }

    /**
     * 交易支付单查询结果
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/planCapitalOrderResJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> planCapitalOrderResJob() {
        planCapitalOrderResJob.doExecute();
        return BaseResult.success(null);
    }

    //    /**
    //     * @return
    //     * @description
    //     */
    //    @RequestMapping(path = "/job/lenderOrgAstClearingOrderJob.json", method = RequestMethod.GET)
    //    public BaseResult<Boolean> lenderOrgAstClearingOrderJob() {
    //        lenderOrgAstClearingOrderJob.doExecute();
    //        return BaseResult.success(null);
    //    }
    //
    //    /**
    //     * @return
    //     * @description
    //     */
    //    @RequestMapping(path = "/job/lenderOrgAstStatJob.json", method = RequestMethod.GET)
    //    public BaseResult<Boolean> lenderOrgAstStatJob() {
    //        lenderOrgAstStatJob.doExecute();
    //        return BaseResult.success(null);
    //    }

    /**
     * 结算单
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/planAstClearingOrderJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> planAstClearingOrderJob() {
        planAstClearingOrderJob.doExecute();
        return BaseResult.success(null);
    }

    /**
     * 资产筛选
     *
     * @return
     * @description
     */
    //    @RequestMapping(path = "/job/planAstMatchJob.json", method = RequestMethod.GET)
    //    public BaseResult<Boolean> planAstMatchJob() {
    //        planAstMatchJob.doExecute();
    //        return BaseResult.success(null);
    //    }

    /**
     * 资产清算统计业务 初始化清算汇总调度任务
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/planAstStatJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> planAstStatJob() {
        planAstStatJob.doExecute();
        return BaseResult.success(null);
    }

    /**
     * 资金资产任务Task生成Job
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/job/capitalAssetMatchJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> capitalAssetMatchJob() {
        capitalAssertMatchJob.doExecute();
        return BaseResult.success(null);
    }


    /**
     * 查询账户余额
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/acct/balance.json", method = RequestMethod.GET)
    public Money acctBalance(String acctNo) {
        return wkPayManager.balance(acctNo, WkChannelNoEnum.BC_YQ0001);
    }

    /**
     * 查询账户余额
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/acct/balance/all.json", method = RequestMethod.GET)
    public List<Account> allBalance() {
        return accountService.queryBalance();
    }

    /**
     * 查询账户余额
     *
     * @return
     * @description
     */
    @RequestMapping(path = "/acct/zlFinSerFeeJob.json", method = RequestMethod.GET)
    public BaseResult<Boolean> zlFinSerFeeJob() {
        zlFinSerFeeJob.doExecute();
        return BaseResult.success(null);
    }

    /**
     * 初始化计划 日报基础数据
     *
     * @param planNo
     * @param date
     * @return
     */
    @RequestMapping(path = "/report/default.json", method = RequestMethod.GET)
    public BaseResult<Boolean> initDefaultReport001(@RequestParam String planNo, @RequestParam String date) {
        // 校验计划
        PlanBase planBase = planManager.getPlanFullByNo(planNo);
        VarChecker.checkNotNull(planBase, "错误的计划编号");
        // 初始化上一日空值报表基础数据
        int cnt = planReportRepo.defaultRPT001Init(planNo, DateUtil.parseDate(date));
        return BaseResult.success(cnt);
    }

    /**
     * 月报手动生成
     *
     * @param planNo
     * @param date
     * @return
     */
    @RequestMapping(path = "/report/month.json", method = RequestMethod.GET)
    public BaseResult<Boolean> initMonthReport(@RequestParam String planNo, @RequestParam String date) {
        PlanBase planBase = planManager.getPlanFullByNo(planNo);
        VarChecker.checkNotNull(planBase, "错误的计划编号");
        // 按日期生成月报
        MutablePair<Boolean, String> rptResult =
            wkPlanReportHandler.checkAndBuildMonthPlanReport(DateUtil.parseDate(date), planBase);
        return BaseResult.success(rptResult);
    }

    /**
     * 日报手动生成
     *
     * @param planNo
     * @param date
     * @return
     */
    @RequestMapping(path = "/report/daily.json", method = RequestMethod.GET)
    public BaseResult<Boolean> initDailyReport(@RequestParam String planNo, @RequestParam String date, Integer count) {
        PlanBase planBase = planManager.getPlanFullByNo(planNo);
        VarChecker.checkNotNull(planBase, "错误的计划编号");

        List<String> planNosBySpvNo = Lists.newArrayList();
        if (planBase.getPlanType() == PlanTypeEnum.SPV) {
            planNosBySpvNo = planRepo.getPlanNosBySpvNo(planBase.getPlanNo());
        }
        int cnt = 1;
        if (ToolUtil.isNotEmpty(count)) {
            cnt = count;
        }
        Day trfDate = orgAcctDayComponent.getTrfAcctDay();
        for (int i = 0; i < cnt; i++) {
            Day acctDate = new Day(DateUtil.offsetDay(DateUtil.parseDate(date), i));
            if (DayUtil.compare(trfDate, acctDate) <= 0) {
                continue;
            }
            PlanReport planReport = planReportRepo.getReport(
                planBase.getPlanNo(), ReportTypeEnum.RPT001, acctDate.getDayString());
            if (planReport != null) {
                continue;
            }
            DailyReportDateField reportDateField = new DailyReportDateField();
            reportDateField.setRptDate(acctDate.getStandardDate());
            // 上一日报表
            PlanReport lastReport = planReportRepo.getReport(
                planBase.getPlanNo(), ReportTypeEnum.RPT001, acctDate.getYesterday().getDayString());
            // 按日期生成日报
            wkPlanReportHandler.buildDailyAstReport(reportDateField, planBase, lastReport, planNosBySpvNo);
        }
        return BaseResult.success("日报生成成功");
    }

    /**
     * 停止放款日后续动作
     *
     * @return
     */
    @RequestMapping(path = "/job/orgcapital.json", method = RequestMethod.GET)
    public BaseResult<Boolean> orgcapital() {
        lenderOrgCapitalJob.doExecute();
        return BaseResult.success(true);
    }

}
