/**
 * abssqr.com Inc.
 * Copyright (c) 2017-2019 All Rights Reserved.
 */
package com.abssqr.plat.web.controller.wkpay;

import javax.servlet.http.HttpServletRequest;

import com.abssqr.plat.common.util.loggers.CommonLoggers;
import com.abssqr.plat.core.service.wk.pay.WkPayManager;
import com.general.system.common.util.LogUtil;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.ResponseBody;
import org.springframework.web.bind.annotation.RestController;

/**
 * @author bangis.wangdf
 * @version com.abssqr.plat.web.controller.callback.wkpay: WkPayController.java, v 0.1 2019-06-21 14:26
 * bangis.wangdf Exp $
 */
@RestController
public class WkPayController {

    @Autowired
    private HttpServletRequest request;
    @Autowired
    private WkPayManager       wkPayManager;

    @RequestMapping(path = "callback/wkpay/trade")
    @ResponseBody
    public String tradeCallBack(@RequestParam(name = "msg") String msg) {
        LogUtil.info(CommonLoggers.WK_INTEGRATION, "msg=[{0}]", msg);
        return "success";
    }

    @RequestMapping(path = "/callback/wkpay/project")
    @ResponseBody
    public String project() {
        wkPayManager.project();
        return "success";
    }

}
